# FO Parameter Reference

$Id: param.xweb 8543 2009-12-02 06:05:24Z bobstayton $
Walsh
Norman
1999
2000
2001
2002
2003
2004
2005
2006
2007
Norman Walsh

This is reference documentation for all user-configurable parameters in the DocBook XSL FO stylesheets (for generating XSL-FO output destined for final print/PDF output).

## Admonitions

admon.graphics
boolean

## admon.graphics

Use graphics in admonitions?

    <xsl:param name="admon.graphics" select="0"></xsl:param>

### Description

If true (non-zero), admonitions are presented in an alternate style that uses a graphic. Default graphics are provided in the distribution.

admon.graphics.extension
string

## admon.graphics.extension

Filename extension for admonition graphics

    <xsl:param name="admon.graphics.extension">.png</xsl:param>

### Description

Sets the filename extension to use on admonition graphics.

admon.graphics.path
string

## admon.graphics.path

Path to admonition graphics

    <xsl:param name="admon.graphics.path">images/</xsl:param>

### Description

Sets the path to the directory containing the admonition graphics (caution.png, important.png etc). This location is normally relative to the output html directory. See `base.dir`

admon.textlabel
boolean

## admon.textlabel

Use text label in admonitions?

    <xsl:param name="admon.textlabel" select="1"></xsl:param>

### Description

If true (non-zero), admonitions are presented with a generated text label such as Note or Warning in the appropriate language. If zero, such labels are turned off, but any title child of the admonition element are still output. The default value is 1.

admonition.title.properties
attribute set

## admonition.title.properties

To set the style for admonitions titles.

    <xsl:attribute-set name="admonition.title.properties">
      <xsl:attribute name="font-size">14pt</xsl:attribute>
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
    </xsl:attribute-set>

### Description

How do you want admonitions titles styled?

Set the font-size, weight etc to the style required.

admonition.properties
attribute set

## admonition.properties

To set the style for admonitions.

    <xsl:attribute-set name="admonition.properties"></xsl:attribute-set>

### Description

How do you want admonitions styled?

Set the font-size, weight, etc. to the style required

graphical.admonition.properties
attribute set

## graphical.admonition.properties

To add properties to the outer block of a graphical admonition.

    <xsl:attribute-set name="graphical.admonition.properties">
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">1.2em</xsl:attribute>
    </xsl:attribute-set>

### Description

These properties are added to the outer block containing the entire graphical admonition, including its title. It is used when the parameter `admon.graphics` is set to nonzero. Use this attribute-set to set the space above and below, and any indent for the whole admonition.

In addition to these properties, a graphical admonition also applies the `admonition.title.properties` attribute-set to the title, and applies the `admonition.properties` attribute-set to the rest of the content.

nongraphical.admonition.properties
attribute set

## nongraphical.admonition.properties

To add properties to the outer block of a nongraphical admonition.

    <xsl:attribute-set name="nongraphical.admonition.properties">
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="margin-{$direction.align.start}">0.25in</xsl:attribute>
      <xsl:attribute name="margin-{$direction.align.end}">0.25in</xsl:attribute>
    </xsl:attribute-set>

### Description

These properties are added to the outer block containing the entire nongraphical admonition, including its title. It is used when the parameter `admon.graphics` is set to zero. Use this attribute-set to set the space above and below, and any indent for the whole admonition.

In addition to these properties, a nongraphical admonition also applies the `admonition.title.properties` attribute-set to the title, and the `admonition.properties` attribute-set to the rest of the content.

## Callouts

callout.defaultcolumn
integer

## callout.defaultcolumn

Indicates what column callouts appear in by default

    <xsl:param name="callout.defaultcolumn">60</xsl:param>

### Description

If a callout does not identify a column (for example, if it uses the `linerange` `unit`), it will appear in the default column.

callout.graphics
boolean

## callout.graphics

Use graphics for callouts?

    <xsl:param name="callout.graphics" select="1"></xsl:param>

### Description

If non-zero, callouts are presented with graphics (e.g., reverse-video circled numbers instead of "(1)", "(2)", etc.). Default graphics are provided in the distribution.

callout.graphics.extension
string

## callout.graphics.extension

Filename extension for callout graphics

    <xsl:param name="callout.graphics.extension">.svg</xsl:param>

### Description

Sets the filename extension to use on callout graphics.

The Docbook XSL distribution provides callout graphics in the following formats:

- SVG (extension: `.svg`)

- PNG (extension: `.png`)

- GIF (extension: `.gif`)

callout.graphics.number.limit
integer

## callout.graphics.number.limit

Number of the largest callout graphic

    <xsl:param name="callout.graphics.number.limit">30</xsl:param>

### Description

If `callout.graphics` is non-zero, graphics are used to represent callout numbers instead of plain text. The value of `callout.graphics.number.limit` is the largest number for which a graphic exists. If the callout number exceeds this limit, the default presentation "(plain text instead of a graphic)" will be used.

callout.graphics.path
string

## callout.graphics.path

Path to callout graphics

    <xsl:param name="callout.graphics.path">images/callouts/</xsl:param>

### Description

Sets the path to the directory holding the callout graphics. his location is normally relative to the output html directory. see base.dir. Always terminate the directory with / since the graphic file is appended to this string, hence needs the separator.

callout.icon.size
length

## callout.icon.size

Specifies the size of callout marker icons

    <xsl:param name="callout.icon.size">7pt</xsl:param>

### Description

Specifies the size of the callout marker icons. The default size is 7 points.

callout.unicode
boolean

## callout.unicode

Use Unicode characters rather than images for callouts.

    <xsl:param name="callout.unicode" select="0"></xsl:param>

### Description

The stylesheets can use either an image of the numbers one to ten, or the single Unicode character which represents the numeral, in white on a black background. Use this to select the Unicode character option.

callout.unicode.font
string

## callout.unicode.font

Specify a font for Unicode glyphs

    <xsl:param name="callout.unicode.font">ZapfDingbats</xsl:param>

### Description

The name of the font to specify around Unicode callout glyphs. If set to the empty string, no font change will occur.

callout.unicode.number.limit
integer

## callout.unicode.number.limit

Number of the largest unicode callout character

    <xsl:param name="callout.unicode.number.limit">10</xsl:param>

### Description

If `callout.unicode` is non-zero, unicode characters are used to represent callout numbers. The value of `callout.unicode.number.limit` is the largest number for which a unicode character exists. If the callout number exceeds this limit, the default presentation "(nnn)" will always be used.

callout.unicode.start.character
integer

## callout.unicode.start.character

First Unicode character to use, decimal value.

    <xsl:param name="callout.unicode.start.character">10102</xsl:param>

### Description

If `callout.graphics` is zero and `callout.unicode` is non-zero, unicode characters are used to represent callout numbers. The value of `callout.unicode.start.character` is the decimal unicode value used for callout number one. Currently, only 10102 is supported in the stylesheets for this parameter.

callouts.extension
boolean

## callouts.extension

Enable the callout extension

    <xsl:param name="callouts.extension" select="1"></xsl:param>

### Description

The callouts extension processes `areaset` elements in `programlistingco` and other text-based callout elements.

## ToC/LoT/Index Generation

autotoc.label.separator
string

## autotoc.label.separator

Separator between labels and titles in the ToC

    <xsl:param name="autotoc.label.separator">. </xsl:param>

### Description

String used to separate labels and titles in a table of contents.

process.empty.source.toc
boolean

## process.empty.source.toc

Generate automated TOC if `toc` element occurs in a source document?

    <xsl:param name="process.empty.source.toc" select="0"></xsl:param>

### Description

Specifies that if an empty `toc` element is found in a source document, an automated TOC is generated at this point in the document.

Depending on what the value of the `generate.toc` parameter is, setting this parameter to `1` could result in generation of duplicate automated TOCs. So the `process.empty.source.toc` is primarily useful as an "override": by placing an empty `toc` in your document and setting this parameter to `1`, you can force a TOC to be generated even if `generate.toc` says not to.

process.source.toc
boolean

## process.source.toc

Process a non-empty `toc` element if it occurs in a source document?

    <xsl:param name="process.source.toc" select="0"></xsl:param>

### Description

Specifies that the contents of a non-empty "hard-coded" `toc` element in a source document are processed to generate a TOC in output.

This parameter has no effect on automated generation of TOCs. An automated TOC may still be generated along with the "hard-coded" TOC. To suppress automated TOC generation, adjust the value of the `generate.toc` paramameter.

The `process.source.toc` parameter also has no effect if the `toc` element is empty; handling for empty `toc` is controlled by the `process.empty.source.toc` parameter.

generate.toc
table

## generate.toc

Control generation of ToCs and LoTs

    <xsl:param name="generate.toc">
    /appendix toc,title
    article/appendix  nop
    /article  toc,title
    book      toc,title,figure,table,example,equation
    /chapter  toc,title
    part      toc,title
    /preface  toc,title
    reference toc,title
    /sect1    toc
    /sect2    toc
    /sect3    toc
    /sect4    toc
    /sect5    toc
    /section  toc
    set       toc,title
    </xsl:param>

### Description

This parameter has a structured value. It is a table of space-delimited path/value pairs. Each path identifies some element in the source document using a restricted subset of XPath (only the implicit child axis, no wildcards, no predicates). Paths can be either relative or absolute.

When processing a particular element, the stylesheets consult this table to determine if a ToC (or LoT(s)) should be generated.

For example, consider the entry:

    book toc,figure

This indicates that whenever a `book` is formatted, a Table Of Contents and a List of Figures should be generated. Similarly,

    /chapter toc

indicates that whenever a document that has a root of `chapter` is formatted, a Table of Contents should be generated. The entry `chapter` would match all chapters, but `/chapter` matches only `chapter` document elements.

Generally, the longest match wins. So, for example, if you want to distinguish articles in books from articles in parts, you could use these two entries:

    book/article toc,figure
    part/article toc

Note that an article in a part can never match a `book/article`, so if you want nothing to be generated for articles in parts, you can simply leave that rule out.

If you want to leave the rule in, to make it explicit that you're turning something off, use the value nop. For example, the following entry disables ToCs and LoTs for articles:

    article nop

Do not simply leave the word article in the file without a matching value. That'd be just begging the silly little path/value parser to get confused.

Section ToCs are further controlled by the `generate.section.toc.level` parameter. For a given section level to have a ToC, it must have both an entry in `generate.toc` and be within the range enabled by `generate.section.toc.level`.

generate.index
boolean

## generate.index

Do you want an index?

    <xsl:param name="generate.index" select="1"></xsl:param>

### Description

Specify if an index should be generated.

make.index.markup
boolean

## make.index.markup

Generate XML index markup in the index?

    <xsl:param name="make.index.markup" select="0"></xsl:param>

### Description

This parameter enables a very neat trick for getting properly merged, collated back-of-the-book indexes. G. Ken Holman suggested this trick at Extreme Markup Languages 2002 and I'm indebted to him for it.

Jeni Tennison's excellent code in `autoidx.xsl` does a great job of merging and sorting `indexterm`s in the document and building a back-of-the-book index. However, there's one thing that it cannot reasonably be expected to do: merge page numbers into ranges. (I would not have thought that it could collate and suppress duplicate page numbers, but in fact it appears to manage that task somehow.)

Ken's trick is to produce a document in which the index at the back of the book is displayed in XML. Because the index is generated by the FO processor, all of the page numbers have been resolved. It's a bit hard to explain, but what it boils down to is that instead of having an index at the back of the book that looks like this:

> #### A

> ap1, 1, 2, 3

you get one that looks like this:

>     <indexdiv>A</indexdiv>
>     <indexentry>
>     <primaryie>ap1</primaryie>,
>     <phrase role="pageno">1</phrase>,
>     <phrase role="pageno">2</phrase>,
>     <phrase role="pageno">3</phrase>
>     </indexentry>

After building a PDF file with this sort of odd-looking index, you can extract the text from the PDF file and the result is a proper index expressed in XML.

Now you have data that's amenable to processing and a simple Perl script (such as `fo/pdf2index`) can merge page ranges and generate a proper index.

Finally, reformat your original document using this literal index instead of an automatically generated one and bingo!

index.method
list
basic
kosek
kimber

## index.method

Select method used to group index entries in an index

    <xsl:param name="index.method">basic</xsl:param>

### Description

This parameter lets you select which method to use for sorting and grouping index entries in an index. Indexes in Latin-based languages that have accented characters typically sort together accented words and unaccented words. Thus Á (U+00C1 LATIN CAPITAL LETTER A WITH ACUTE) would sort together with A (U+0041 LATIN CAPITAL LETTER A), so both would appear in the A section of the index. Languages using other alphabets (such as Russian, which is written in the Cyrillic alphabet) and languages using ideographic chararacters (such as Japanese) require grouping specific to the languages and alphabets.

The default indexing method is limited. It can group accented characters in Latin-based languages only. It cannot handle non-Latin alphabets or ideographic languages. The other indexing methods require extensions of one type or another, and do not work with all XSLT processors, which is why they are not used by default.

The three choices for indexing method are:

`basic`

  (default) Sort and groups words based only on the Latin alphabet. Words with accented Latin letters will group and sort with their respective primary letter, but words in non-Latin alphabets will be put in the Symbols section of the index.

`kosek`

  This method sorts and groups words based on letter groups configured in the DocBook locale file for the given language. See, for example, the French locale file `common/fr.xml`. This method requires that the XSLT processor supports the EXSLT extensions (most do). It also requires support for using user-defined functions in xsl:key (xsltproc does not).

  This method is suitable for any language for which you can list all the individual characters that should appear in each letter group in an index. It is probably not practical to use it for ideographic languages such as Chinese that have hundreds or thousands of characters.

  To use the kosek method, you must:

  1. Use a processor that supports its extensions, such as Saxon 6 or Xalan (xsltproc and Saxon 8 do not).

  2. Set the index.method parameter's value to kosek.

  3. Import the appropriate index extensions stylesheet module `fo/autoidx-kosek.xsl` or `html/autoidx-kosek.xsl` into your customization.

`kimber`

  This method uses extensions to the Saxon processor to implement sophisticated indexing processes. It uses its own configuration file, which can include information for any number of languages. Each language's configuration can group words using one of two processes. In the enumerated process similar to that used in the kosek method, you indicate the groupings character-by-character. In the between-key process, you specify the break-points in the sort order that should start a new group. The latter configuration is useful for ideographic languages such as Chinese, Japanese, and Korean. You can also define your own collation algorithms and how you want mixed Latin-alphabet words sorted.

  - For a whitepaper describing the extensions, see: http://www.innodata-isogen.com/knowledge_center/white_papers/back_of_book_for_xsl_fo.pdf.

  - To download the extension library, see http://www.innodata-isogen.com/knowledge_center/tools_downloads/i18nsupport.

  To use the kimber method, you must:

  1. Use Saxon (version 6 or 8) as your XSLT processor.

  2. Install and configure the Innodata Isogen library, using the documentation that comes with it.

  3. Set the index.method parameter's value to kimber.

  4. Import the appropriate index extensions stylesheet module `fo/autoidx-kimber.xsl` or `html/autoidx-kimber.xsl` into your customization.

index.on.type
boolean

## index.on.type

Select indexterms based on `type` attribute value

    <xsl:param name="index.on.type" select="0"></xsl:param>

### Description

If non-zero, then an `index` element that has a `type` attribute value will contain only those `indexterm` elements with a matching `type` attribute value. If an `index` has no `type` attribute or it is blank, then the index will contain all `indexterm`s in the current scope.

If `index.on.type` is zero, then the `type` attribute has no effect on selecting indexterms for an index.

For those using DocBook version 4.2 or earlier, the `type` attribute is not available for index terms. However, you can achieve the same effect by using the `role` attribute in the same manner on `indexterm` and `index`, and setting the stylesheet parameter `index.on.role` to a nonzero value.

index.on.role
boolean

## index.on.role

Select indexterms based on `role` value

    <xsl:param name="index.on.role" select="0"></xsl:param>

### Description

If non-zero, then an `index` element that has a `role` attribute value will contain only those `indexterm` elements with a matching role value. If an `index` has no `role` attribute or it is blank, then the index will contain all `indexterm`s in the current scope.

If `index.on.role` is zero, then the `role` attribute has no effect on selecting indexterms for an index.

If you are using DocBook version 4.3 or later, you should use the `type` attribute instead of `role` on `indexterm` and `index`, and set the `index.on.type` to a nonzero value.

index.preferred.page.properties
attribute set

## index.preferred.page.properties

Properties used to emphasize page number references for significant index terms

    <xsl:attribute-set name="index.preferred.page.properties">
      <xsl:attribute name="font-weight">bold</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties used to emphasize page number references for significant index terms (`significance`=`preferred`). Currently works only with XEP.

index.entry.properties
attribute set

## index.entry.properties

Properties applied to the formatted entries in an index

    <xsl:attribute-set name="index.entry.properties">
      <xsl:attribute name="start-indent">0pt</xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is applied to the block containing the entries in a letter division in an index. It can be used to set the font-size, font-family, and other inheritable properties that will be applied to all index entries.

index.div.title.properties
attribute set

## index.div.title.properties

Properties associated with the letter headings in an index

    <xsl:attribute-set name="index.div.title.properties">
      <xsl:attribute name="margin-{$direction.align.start}">0pt</xsl:attribute>
      <xsl:attribute name="font-size">14.4pt</xsl:attribute>
      <xsl:attribute name="font-family"><xsl:value-of select="$title.fontset"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="space-before.optimum"><xsl:value-of select="concat($body.font.master,'pt')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="space-before.minimum"><xsl:value-of select="concat($body.font.master,'pt * 0.8')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="space-before.maximum"><xsl:value-of select="concat($body.font.master,'pt * 1.2')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="start-indent">0pt</xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is used on the letter headings that separate the divisions in an index.

index.number.separator
string

## index.number.separator

Override for punctuation separating page numbers in index

    <xsl:param name="index.number.separator"></xsl:param>

### Description

This parameter permits you to override the text to insert between page references in a formatted index entry. Typically that would be a comma and a space.

Because this text may be locale dependent, this parameter's value is normally taken from a gentext template named 'number-separator' in the context 'index' in the stylesheet locale file for the language of the current document. This parameter can be used to override the gentext string, and would typically be used on the command line. This parameter would apply to all languages.

So this text string can be customized in two ways. You can reset the default gentext string using the `local.l10n.xml` parameter, or you can override the gentext with the content of this parameter. The content can be a simple string, or it can be something more complex such as a call-template.

In HTML index output, section title references are used instead of page number references. This punctuation appears between such section titles in an HTML index.

index.range.separator
string

## index.range.separator

Override for punctuation separating the two numbers in a page range in index

    <xsl:param name="index.range.separator"></xsl:param>

### Description

This parameter permits you to override the text to insert between the two numbers of a page range in an index. This parameter is only used by those XSL-FO processors that support an extension for generating such page ranges (such as XEP).

Because this text may be locale dependent, this parameter's value is normally taken from a gentext template named 'range-separator' in the context 'index' in the stylesheet locale file for the language of the current document. This parameter can be used to override the gentext string, and would typically be used on the command line. This parameter would apply to all languages.

So this text string can be customized in two ways. You can reset the default gentext string using the `local.l10n.xml` parameter, or you can override the gentext with the content of this parameter. The content can be a simple string, or it can be something more complex such as a call-template.

In HTML index output, section title references are used instead of page number references. So there are no page ranges and this parameter has no effect.

index.term.separator
string

## index.term.separator

Override for punctuation separating an index term from its list of page references in an index

    <xsl:param name="index.term.separator"></xsl:param>

### Description

This parameter permits you to override the text to insert between the end of an index term and its list of page references. Typically that might be a comma and a space.

Because this text may be locale dependent, this parameter's value is normally taken from a gentext template named 'term-separator' in the context 'index' in the stylesheet locale file for the language of the current document. This parameter can be used to override the gentext string, and would typically be used on the command line. This parameter would apply to all languages.

So this text string can be customized in two ways. You can reset the default gentext string using the `local.l10n.xml` parameter, or you can fill in the content for this normally empty override parameter. The content can be a simple string, or it can be something more complex such as a call-template. For fo output, it could be an `fo:leader` element to provide space of a specific length, or a dot leader.

xep.index.item.properties
attribute set

## xep.index.item.properties

Properties associated with XEP index-items

    <xsl:attribute-set name="xep.index.item.properties" use-attribute-sets="index.page.number.properties">
      <xsl:attribute name="merge-subsequent-page-numbers">true</xsl:attribute>
      <xsl:attribute name="link-back">true</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties associated with XEP index-items, which generate page numbers in an index processed by XEP. For more info see the XEP documentation section "Indexes" in `http://www.renderx.com/reference.html#Indexes`.

This attribute-set also adds by default any properties from the `index.page.number.properties` attribute-set.

toc.section.depth
integer

## toc.section.depth

How deep should recursive `section`s appear in the TOC?

    <xsl:param name="toc.section.depth">2</xsl:param>

### Description

Specifies the depth to which recursive sections should appear in the TOC.

toc.max.depth
integer

## toc.max.depth

How many levels should be created for each TOC?

    <xsl:param name="toc.max.depth">8</xsl:param>

### Description

Specifies the maximal depth of TOC on all levels.

toc.indent.width
float

## toc.indent.width

Amount of indentation for TOC entries

    <xsl:param name="toc.indent.width">24</xsl:param>
    <!-- inconsistant point specification? -->

### Description

Specifies, in points, the distance by which each level of the TOC is indented from its parent.

This value is expressed in points, without a unit (in other words, it is a bare number). Using a bare number allows the stylesheet to perform calculations that would otherwise have to be performed by the FO processor because not all processors support expressions.

toc.line.properties
attribute set

## toc.line.properties

Properties for lines in ToCs and LoTs

    <xsl:attribute-set name="toc.line.properties">
      <xsl:attribute name="text-align-last">justify</xsl:attribute>
      <xsl:attribute name="text-align">start</xsl:attribute>
      <xsl:attribute name="end-indent"><xsl:value-of select="concat($toc.indent.width, 'pt')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="last-line-end-indent"><xsl:value-of select="concat('-', $toc.indent.width, 'pt')"></xsl:value-of></xsl:attribute>
    </xsl:attribute-set>

### Description

Properties which are applied to every line in ToC (or LoT). You can modify them in order to change appearance of all, or some lines. For example, in order to make lines for chapters bold, specify the following in your customization layer:

    <xsl:attribute-set name="toc.line.properties">
      <xsl:attribute name="font-weight">
       <xsl:choose>
        <xsl:when test="self::chapter">bold</xsl:when>
        <xsl:otherwise>normal</xsl:otherwise>
       </xsl:choose>
      </xsl:attribute>
    </xsl:attribute-set>

toc.margin.properties
attribute set

## toc.margin.properties

Margin properties used on Tables of Contents

    <xsl:attribute-set name="toc.margin.properties">
      <xsl:attribute name="space-before.minimum">0.5em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">2em</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.5em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">2em</xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is used on Tables of Contents. These attributes are set on the wrapper that surrounds the ToC block, not on each individual lines.

bridgehead.in.toc
boolean

## bridgehead.in.toc

Should bridgehead elements appear in the TOC?

    <xsl:param name="bridgehead.in.toc" select="0"></xsl:param>

### Description

If non-zero, `bridgehead`s appear in the TOC. Note that this option is not fully supported and may be removed in a future version of the stylesheets.

simplesect.in.toc
boolean

## simplesect.in.toc

Should `simplesect` elements appear in the TOC?

    <xsl:param name="simplesect.in.toc" select="0"></xsl:param>

### Description

If non-zero, `simplesect`s will be included in the TOC.

generate.section.toc.level
integer

## generate.section.toc.level

Control depth of TOC generation in sections

    <xsl:param name="generate.section.toc.level" select="0"></xsl:param>

### Description

The `generate.section.toc.level` parameter controls the depth of `section` in which TOCs will be generated. Note that this is related to, but not the same as `toc.section.depth`, which controls the depth to which TOC entries will be generated in a given TOC.

If, for example, `generate.section.toc.level` is `3`, TOCs will be generated in first, second, and third level sections, but not in fourth level sections.

## Processor Extensions

arbortext.extensions
boolean

## arbortext.extensions

Enable Arbortext extensions?

    <xsl:param name="arbortext.extensions" select="0"></xsl:param>

### Description

If non-zero, Arbortext extensions will be used.

This parameter can also affect which graphics file formats are supported

axf.extensions
boolean

## axf.extensions

Enable XSL Formatter extensions?

    <xsl:param name="axf.extensions" select="0"></xsl:param>

### Description

If non-zero, XSL Formatter extensions will be used. XSL Formatter extensions consists of PDF bookmarks, document information and better index processing.

This parameter can also affect which graphics file formats are supported

fop.extensions
boolean

## fop.extensions

Enable extensions for FOP version 0.20.5 and earlier

    <xsl:param name="fop.extensions" select="0"></xsl:param>

### Description

If non-zero, extensions intended for FOP version 0.20.5 and earlier will be used. At present, this consists of PDF bookmarks.

This parameter can also affect which graphics file formats are supported.

If you are using a version of FOP beyond version 0.20.5, then use the `fop1.extensions` parameter instead.

fop1.extensions
boolean

## fop1.extensions

Enable extensions for FOP version 0.90 and later

    <xsl:param name="fop1.extensions" select="0"></xsl:param>

### Description

If non-zero, extensions for FOP version 0.90 and later will be used.

This parameter can also affect which graphics file formats are supported.

The original `fop.extensions` parameter should still be used for FOP version 0.20.5 and earlier.

passivetex.extensions
boolean

## passivetex.extensions

Enable PassiveTeX extensions?

    <xsl:param name="passivetex.extensions" select="0"></xsl:param>

### Description

If non-zero, PassiveTeX extensions will be used. At present, this consists of PDF bookmarks and sorted index terms.

This parameter can also affect which graphics file formats are supported

PassiveTeX is incomplete and development has ceased. In most cases, another XSL-FO engine is probably a better choice.

tex.math.in.alt
list
plain
latex

## tex.math.in.alt

TeX notation used for equations

    <xsl:param name="tex.math.in.alt"></xsl:param>

### Description

If you want type math directly in TeX notation in equations, this parameter specifies notation used. Currently are supported two values -- `plain` and `latex`. Empty value means that you are not using TeX math at all.

Preferred way for including TeX alternative of math is inside of `textobject` element. Eg.:

    <inlineequation>
    <inlinemediaobject>
    <imageobject>
    <imagedata fileref="eq1.gif"/>
    </imageobject>
    <textobject><phrase>E=mc squared</phrase></textobject>
    <textobject role="tex"><phrase>E=mc^2</phrase></textobject>
    </inlinemediaobject>
    </inlineequation>

If you are using `graphic` element, you can store TeX inside `alt` element:

    <inlineequation>
    <alt role="tex">a^2+b^2=c^2</alt>
    <graphic fileref="a2b2c2.gif"/>
    </inlineequation>

If you want use this feature, you should process your FO with PassiveTeX, which only supports TeX math notation. When calling stylsheet, don't forget to specify also passivetex.extensions=1.

If you want equations in HTML, just process generated file `tex-math-equations.tex` by TeX or LaTeX. Then run dvi2bitmap program on result DVI file. You will get images for equations in your document.

This feature is useful for print/PDF output only if you use the obsolete and now unsupported PassiveTeX XSL-FO engine.

### Related Parameters

`tex.math.delims`, `passivetex.extensions`, `tex.math.file`

tex.math.delims
boolean

## tex.math.delims

Should equations output for processing by TeX be surrounded by math mode delimiters?

    <xsl:param name="tex.math.delims" select="1"></xsl:param>

### Description

For compatibility with DSSSL based DBTeXMath from Allin Cottrell you should set this parameter to 0.

This feature is useful for print/PDF output only if you use the obsolete and now unsupported PassiveTeX XSL-FO engine.

### Related Parameters

`tex.math.in.alt`, `passivetex.extensions`

### See Also

You can also use the `dbtex delims` processing instruction to control whether delimiters are output.

xep.extensions
boolean

## xep.extensions

Enable XEP extensions?

    <xsl:param name="xep.extensions" select="0"></xsl:param>

### Description

If non-zero, XEP extensions will be used. XEP extensions consists of PDF bookmarks, document information and better index processing.

This parameter can also affect which graphics file formats are supported

## Stylesheet Extensions

linenumbering.everyNth
integer

## linenumbering.everyNth

Indicate which lines should be numbered

    <xsl:param name="linenumbering.everyNth">5</xsl:param>

### Description

If line numbering is enabled, everyNth line will be numbered. Note that numbering is one based, not zero based.

linenumbering.extension
boolean

## linenumbering.extension

Enable the line numbering extension

    <xsl:param name="linenumbering.extension" select="1"></xsl:param>

### Description

If non-zero, verbatim environments (`address`, `literallayout`, `programlisting`, `screen`, `synopsis`) that specify line numbering will have line numbers.

linenumbering.separator
string

## linenumbering.separator

Specify a separator between line numbers and lines

    <xsl:param name="linenumbering.separator"><xsl:text> </xsl:text></xsl:param>

### Description

The separator is inserted between line numbers and lines in the verbatim environment. The default value is a single white space. Note the interaction with `linenumbering.width`

linenumbering.width
integer

## linenumbering.width

Indicates the width of line numbers

    <xsl:param name="linenumbering.width">3</xsl:param>

### Description

If line numbering is enabled, line numbers will appear right justified in a field "width" characters wide.

tablecolumns.extension
boolean

## tablecolumns.extension

Enable the table columns extension function

    <xsl:param name="tablecolumns.extension" select="1"></xsl:param>

### Description

The table columns extension function adjusts the widths of table columns in the HTML result to more accurately reflect the specifications in the CALS table.

textinsert.extension
boolean

## textinsert.extension

Enables the textinsert extension element

      <xsl:param name="textinsert.extension" select="1"></xsl:param>

### Description

The textinsert extension element inserts the contents of a file into the result tree (as text).

To use the textinsert extension element, you must use either Saxon or Xalan as your XSLT processor (it doesn’t work with xsltproc), along with either the DocBook Saxon extensions or DocBook Xalan extensions (for more information about those extensions, see DocBook Saxon Extensions and DocBook Xalan Extensions), and you must set both the `use.extensions` and `textinsert.extension` parameters to `1`.

As an alternative to using the textinsert element, consider using an Xinclude element with the `parse="text"` attribute and value specified, as detailed in Using XInclude for text inclusions.

### See Also

You can also use the `dbhtml-include href` processing instruction to insert external files — both files containing plain text and files with markup content (including HTML content).

### More information

For how-to documentation on inserting contents of external code files and other text files into output, see External code files.

For guidelines on inserting contents of HTML files into output, see Inserting external HTML code.

textdata.default.encoding
string

## textdata.default.encoding

Default encoding of external text files which are included using textdata element

    <xsl:param name="textdata.default.encoding"></xsl:param>

### Description

Specifies the encoding of any external text files included using `textdata` element. This value is used only when you do not specify encoding by the appropriate attribute directly on textdata. An empty string is interpreted as the system default encoding.

use.extensions
boolean

## use.extensions

Enable extensions

    <xsl:param name="use.extensions" select="0"></xsl:param>

### Description

If non-zero, extensions may be used. Each extension is further controlled by its own parameter. But if `use.extensions` is zero, no extensions will be used.

## Automatic labelling

appendix.autolabel
list
0none
11,2,3...
AA,B,C...
aa,b,c...
ii,ii,iii...
II,II,III...

## appendix.autolabel

Specifies the labeling format for Appendix titles

    <xsl:param name="appendix.autolabel">A</xsl:param>

### Description

If non-zero, then appendices will be numbered using the parameter value as the number format if the value matches one of the following:

1 or arabic

  Arabic numeration (1, 2, 3 ...).

A or upperalpha

  Uppercase letter numeration (A, B, C ...).

a or loweralpha

  Lowercase letter numeration (a, b, c ...).

I or upperroman

  Uppercase roman numeration (I, II, III ...).

i or lowerroman

  Lowercase roman letter numeration (i, ii, iii ...).

Any nonzero value other than the above will generate the default number format (upperalpha).

chapter.autolabel
list
0none
11,2,3...
AA,B,C...
aa,b,c...
ii,ii,iii...
II,II,III...

## chapter.autolabel

Specifies the labeling format for Chapter titles

    <xsl:param name="chapter.autolabel" select="1"></xsl:param>

### Description

If non-zero, then chapters will be numbered using the parameter value as the number format if the value matches one of the following:

1 or arabic

  Arabic numeration (1, 2, 3 ...).

A or upperalpha

  Uppercase letter numeration (A, B, C ...).

a or loweralpha

  Lowercase letter numeration (a, b, c ...).

I or upperroman

  Uppercase roman numeration (I, II, III ...).

i or lowerroman

  Lowercase roman letter numeration (i, ii, iii ...).

Any nonzero value other than the above will generate the default number format (arabic).

part.autolabel
list
0none
11,2,3...
AA,B,C...
aa,b,c...
ii,ii,iii...
II,II,III...

## part.autolabel

Specifies the labeling format for Part titles

    <xsl:param name="part.autolabel">I</xsl:param>

### Description

If non-zero, then parts will be numbered using the parameter value as the number format if the value matches one of the following:

1 or arabic

  Arabic numeration (1, 2, 3 ...).

A or upperalpha

  Uppercase letter numeration (A, B, C ...).

a or loweralpha

  Lowercase letter numeration (a, b, c ...).

I or upperroman

  Uppercase roman numeration (I, II, III ...).

i or lowerroman

  Lowercase roman letter numeration (i, ii, iii ...).

Any nonzero value other than the above will generate the default number format (upperroman).

reference.autolabel
list
0none
11,2,3...
AA,B,C...
aa,b,c...
ii,ii,iii...
II,II,III...

## reference.autolabel

Specifies the labeling format for Reference titles

      <xsl:param name="reference.autolabel">I</xsl:param>

### Description

If non-zero, references will be numbered using the parameter value as the number format if the value matches one of the following:

1 or arabic

  Arabic numeration (1, 2, 3 ...).

A or upperalpha

  Uppercase letter numeration (A, B, C ...).

a or loweralpha

  Lowercase letter numeration (a, b, c ...).

I or upperroman

  Uppercase roman numeration (I, II, III ...).

i or lowerroman

  Lowercase roman letter numeration (i, ii, iii ...).

Any non-zero value other than the above will generate the default number format (upperroman).

preface.autolabel
list
0none
11,2,3...
AA,B,C...
aa,b,c...
ii,ii,iii...
II,II,III...

## preface.autolabel

Specifices the labeling format for Preface titles

    <xsl:param name="preface.autolabel" select="0"></xsl:param>

### Description

If non-zero then prefaces will be numbered using the parameter value as the number format if the value matches one of the following:

1 or arabic

  Arabic numeration (1, 2, 3 ...).

A or upperalpha

  Uppercase letter numeration (A, B, C ...).

a or loweralpha

  Lowercase letter numeration (a, b, c ...).

I or upperroman

  Uppercase roman numeration (I, II, III ...).

i or lowerroman

  Lowercase roman letter numeration (i, ii, iii ...).

Any nonzero value other than the above will generate the default number format (arabic).

section.autolabel
boolean

## section.autolabel

Are sections enumerated?

    <xsl:param name="section.autolabel" select="0"></xsl:param>

### Description

If true (non-zero), unlabeled sections will be enumerated.

section.autolabel.max.depth
integer

## section.autolabel.max.depth

The deepest level of sections that are numbered.

    <xsl:param name="section.autolabel.max.depth">8</xsl:param>

### Description

When section numbering is turned on by the `section.autolabel` parameter, then this parameter controls the depth of `section` nesting that is numbered. Sections nested to a level deeper than this value will not be numbered.

section.label.includes.component.label
boolean

## section.label.includes.component.label

Do section labels include the component label?

    <xsl:param name="section.label.includes.component.label" select="0"></xsl:param>

### Description

If non-zero, section labels are prefixed with the label of the component that contains them.

label.from.part
boolean

## label.from.part

Renumber components in each part?

    <xsl:param name="label.from.part" select="0"></xsl:param>

### Description

If `label.from.part` is non-zero, then numbering of components — `preface`, `chapter`, `appendix`, and `reference` (when `reference` occurs at the component level) — is re-started within each `part`.

If `label.from.part` is zero (the default), numbering of components is not re-started within each `part`; instead, components are numbered sequentially throughout each `book`, regardless of whether or not they occur within `part` instances.

component.label.includes.part.label
boolean

## component.label.includes.part.label

Do component labels include the part label?

    <xsl:param name="component.label.includes.part.label" select="0"></xsl:param>

### Description

If non-zero, number labels for `chapter`, `appendix`, and other component elements are prefixed with the label of the part element that contains them. So you might see Chapter II.3 instead of Chapter 3. Also, the labels for formal elements such as `table` and `figure` will include the part label. If there is no part element container, then no prefix is generated.

This feature is most useful when the `label.from.part` parameter is turned on. In that case, there would be more than one `chapter` 1, and the extra part label prefix will identify each chapter unambiguously.

## XSLT Processing

rootid
string

## rootid

Specify the root element to format

    <xsl:param name="rootid"></xsl:param>

### Description

If `rootid` is not empty, it must be the value of an ID that occurs in the document being formatted. The entire document will be loaded and parsed, but formatting will begin at the element identified, rather than at the root. For example, this allows you to process only `chapter` 4 of a `book`.

Because the entire document is available to the processor, automatic numbering, cross references, and other dependencies are correctly resolved.

## Meta/*Info

make.single.year.ranges
boolean

## make.single.year.ranges

Print single-year ranges (e.g., 1998-1999)

    <xsl:param name="make.single.year.ranges" select="0"></xsl:param>

### Description

If non-zero, year ranges that span a single year will be printed in range notation (1998-1999) instead of discrete notation (1998, 1999).

make.year.ranges
boolean

## make.year.ranges

Collate copyright years into ranges?

    <xsl:param name="make.year.ranges" select="0"></xsl:param>

### Description

If non-zero, multiple copyright `year` elements will be collated into ranges. This works only if each year number is put into a separate year element. The copyright element permits multiple year elements. If a year element contains a dash or a comma, then that year element will not be merged into any range.

author.othername.in.middle
boolean

## author.othername.in.middle

Is `othername` in `author` a middle name?

    <xsl:param name="author.othername.in.middle" select="1"></xsl:param>

### Description

If non-zero, the `othername` of an `author` appears between the `firstname` and `surname`. Otherwise, `othername` is suppressed.

## Reference Pages

funcsynopsis.decoration
boolean

## funcsynopsis.decoration

Decorate elements of a `funcsynopsis`?

    <xsl:param name="funcsynopsis.decoration" select="1"></xsl:param>

### Description

If non-zero, elements of the `funcsynopsis` will be decorated (e.g. rendered as bold or italic text). The decoration is controlled by templates that can be redefined in a customization layer.

funcsynopsis.style
list
ansi
kr

## funcsynopsis.style

What style of `funcsynopsis` should be generated?

    <xsl:param name="funcsynopsis.style">kr</xsl:param>

### Description

If `funcsynopsis.style` is `ansi`, ANSI-style function synopses are generated for a `funcsynopsis`, otherwise K&R-style function synopses are generated.

function.parens
boolean

## function.parens

Generate parens after a function?

    <xsl:param name="function.parens" select="0"></xsl:param>

### Description

If non-zero, the formatting of a `function` element will include generated parentheses.

refentry.generate.name
boolean

## refentry.generate.name

Output NAME header before `refname`s?

    <xsl:param name="refentry.generate.name" select="1"></xsl:param>

### Description

If non-zero, a "NAME" section title is output before the list of `refname`s. This parameter and `refentry.generate.title` are mutually exclusive. This means that if you change this parameter to zero, you should set `refentry.generate.title` to non-zero unless you want get quite strange output.

refentry.generate.title
boolean

## refentry.generate.title

Output title before `refname`s?

    <xsl:param name="refentry.generate.title" select="0"></xsl:param>

### Description

If non-zero, the reference page title or first name is output before the list of `refname`s. This parameter and `refentry.generate.name` are mutually exclusive. This means that if you change this parameter to non-zero, you should set `refentry.generate.name` to zero unless you want get quite strange output.

refentry.pagebreak
boolean

## refentry.pagebreak

Start each refentry on a new page

    <xsl:param name="refentry.pagebreak" select="1"></xsl:param>

### Description

If non-zero (the default), each `refentry` element will start on a new page. If zero, a page break will not be generated between `refentry` elements. The exception is when the `refentry` elements are children of a `part` element, in which case the page breaks are always retained. That is because a `part` element does not generate a page-sequence for its children, so each `refentry` must start its own page-sequence.

refentry.title.properties
attribute set

## refentry.title.properties

Title properties for a refentry title

    <xsl:attribute-set name="refentry.title.properties">
      <xsl:attribute name="font-family">
        <xsl:value-of select="$title.font.family"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="font-size">18pt</xsl:attribute>
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <xsl:attribute name="space-after">1em</xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1.0em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">0.5em</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.4em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">0.6em</xsl:attribute>
      <xsl:attribute name="start-indent"><xsl:value-of select="$title.margin.left"></xsl:value-of></xsl:attribute>
    </xsl:attribute-set>

### Description

Formatting properties applied to the title generated for the `refnamediv` part of output for `refentry` when the value of the `refentry.generate.title` parameter is non-zero. The font size is supplied by the appropriate `section.levelX.title.properties` attribute-set, computed from the location of the `refentry` in the section hierarchy.

This parameter has no effect on the the title generated for the `refnamediv` part of output for `refentry` when the value of the `refentry.generate.name` parameter is non-zero. By default, that title is formatted with the same properties as the titles for all other first-level children of `refentry`.

refentry.xref.manvolnum
boolean

## refentry.xref.manvolnum

Output `manvolnum` as part of `refentry` cross-reference?

    <xsl:param name="refentry.xref.manvolnum" select="1"></xsl:param>

### Description

if non-zero, the `manvolnum` is used when cross-referencing `refentry`s, either with `xref` or `citerefentry`.

refclass.suppress
boolean

## refclass.suppress

Suppress display of refclass contents?

    <xsl:param name="refclass.suppress" select="0"></xsl:param>

### Description

If the value of `refclass.suppress` is non-zero, then display of `refclass` contents is suppressed in output.

## Tables

default.table.width
length

## default.table.width

The default width of tables

    <xsl:param name="default.table.width"></xsl:param>

### Description

If non-zero, this value will be used for the `width` attribute on `table`s that do not specify an alternate width (with the `dbhtml table-width` or `dbfo table-width` processing instruction).

nominal.table.width
length

## nominal.table.width

The (absolute) nominal width of tables

    <xsl:param name="nominal.table.width">6in</xsl:param>

### Description

In order to convert CALS column widths into HTML column widths, it is sometimes necessary to have an absolute table width to use for conversion of mixed absolute and relative widths. This value must be an absolute length (not a percentage).

default.table.frame
string

## default.table.frame

The default framing of tables

    <xsl:param name="default.table.frame">all</xsl:param>

### Description

This value will be used when there is no frame attribute on the table.

default.table.rules
string

## default.table.rules

The default column and row rules for tables using HTML markup

    <xsl:param name="default.table.rules">none</xsl:param>

### Description

Tables using HTML markup elements can use an attribute named `rules` on the `table` or `informaltable` element to specify whether column and row border rules should be displayed. This parameter lets you specify a global default style for all HTML tables that don't otherwise have that attribute.

These are the supported values:

all

  Rules will appear between all rows and columns.

rows

  Rules will appear between rows only.

cols

  Rules will appear between columns only.

groups

  Rules will appear between row groups (thead, tfoot, tbody). No support for rules between column groups yet.

none

  No rules. This is the default value.

The border after the last row and the border after the last column are not affected by this setting. Those borders are controlled by the `frame` attribute on the table element.

table.cell.padding
attribute set

## table.cell.padding

Specifies the padding of table cells

    <xsl:attribute-set name="table.cell.padding">
      <xsl:attribute name="padding-start">2pt</xsl:attribute>
      <xsl:attribute name="padding-end">2pt</xsl:attribute>
      <xsl:attribute name="padding-top">2pt</xsl:attribute>
      <xsl:attribute name="padding-bottom">2pt</xsl:attribute>
    </xsl:attribute-set>

### Description

Specifies the padding of table cells.

table.frame.border.thickness
length

## table.frame.border.thickness

Specifies the thickness of the frame border

    <xsl:param name="table.frame.border.thickness">0.5pt</xsl:param>

### Description

Specifies the thickness of the border on the table's frame.

table.frame.border.style
list
none
solid
dotted
dashed
double
groove
ridge
inset
outset
solid

## table.frame.border.style

Specifies the border style of table frames

    <xsl:param name="table.frame.border.style">solid</xsl:param>

### Description

Specifies the border style of table frames.

table.frame.border.color
color

## table.frame.border.color

Specifies the border color of table frames

    <xsl:param name="table.frame.border.color">black</xsl:param>

### Description

Specifies the border color of table frames.

table.cell.border.thickness
length

## table.cell.border.thickness

Specifies the thickness of table cell borders

    <xsl:param name="table.cell.border.thickness">0.5pt</xsl:param>

### Description

If non-zero, specifies the thickness of borders on table cells. The units are points. See CSS

To control properties of cell borders in HTML output, you must also turn on the `table.borders.with.css` parameter.

table.cell.border.style
list
none
solid
dotted
dashed
double
groove
ridge
inset
outset
solid

## table.cell.border.style

Specifies the border style of table cells

    <xsl:param name="table.cell.border.style">solid</xsl:param>

### Description

Specifies the border style of table cells.

To control properties of cell borders in HTML output, you must also turn on the `table.borders.with.css` parameter.

table.cell.border.color
color

## table.cell.border.color

Specifies the border color of table cells

    <xsl:param name="table.cell.border.color">black</xsl:param>

### Description

Set the color of table cell borders. If non-zero, the value is used for the border coloration. See CSS. A `color` is either a keyword or a numerical RGB specification. Keywords are aqua, black, blue, fuchsia, gray, green, lime, maroon, navy, olive, orange, purple, red, silver, teal, white, and yellow.

To control properties of cell borders in HTML output, you must also turn on the `table.borders.with.css` parameter.

table.table.properties
attribute set

## table.table.properties

Properties associated with a table

    <xsl:attribute-set name="table.table.properties">
      <xsl:attribute name="border-before-width.conditionality">retain</xsl:attribute>
      <xsl:attribute name="border-collapse">collapse</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for tables. This parameter should really have been called `table.properties`, but that parameter name was inadvertently established for the block-level properties of the table as a whole.

See also `table.properties`.

## Linking

current.docid
string

## current.docid

targetdoc identifier for the document being processed

    <xsl:param name="current.docid"></xsl:param>

### Description

When olinks between documents are resolved for HTML output, the stylesheet can compute the relative path between the current document and the target document. The stylesheet needs to know the `targetdoc` identifiers for both documents, as they appear in the `target.database.document` database file. This parameter passes to the stylesheet the targetdoc identifier of the current document, since that identifier does not appear in the document itself.

This parameter can also be used for print output. If an olink's `targetdoc` id differs from the `current.docid`, then the stylesheet can append the target document's title to the generated olink text. That identifies to the reader that the link is to a different document, not the current document. See also `olink.doctitle` to enable that feature.

collect.xref.targets
list
no
yes
only

## collect.xref.targets

Controls whether cross reference data is collected

    <xsl:param name="collect.xref.targets">no</xsl:param>

### Description

In order to resolve olinks efficiently, the stylesheets can generate an external data file containing information about all potential cross reference endpoints in a document. This parameter determines whether the collection process is run when the document is processed by the stylesheet. The default value is `no`, which means the data file is not generated during processing. The other choices are `yes`, which means the data file is created and the document is processed for output, and `only`, which means the data file is created but the document is not processed for output. See also `targets.filename`.

insert.olink.page.number
list
no
yes
maybe

## insert.olink.page.number

Turns page numbers in olinks on and off

    <xsl:param name="insert.olink.page.number">no</xsl:param>

### Description

The value of this parameter determines if cross references made between documents with `olink` will include page number citations. In most cases this is only applicable to references in printed output.

The parameter has three possible values.

no

  No page number references will be generated for olinks.

yes

  Page number references will be generated for all `olink` references. The style of page reference may be changed if an `xrefstyle` attribute is used.

maybe

  Page number references will not be generated for an `olink` element unless it has an `xrefstyle` attribute whose value specifies a page reference.

Olinks that point to targets within the same document are treated as `xref`s, and controlled by the `insert.xref.page.number` parameter.

Page number references for olinks to external documents can only be inserted if the information exists in the olink database. This means each olink target element (`div` or `obj`) must have a `page` attribute whose value is its page number in the target document. The XSL stylesheets are not able to extract that information during processing because pages have not yet been created in XSLT transformation. Only the XSL-FO processor knows what page each element is placed on. Therefore some postprocessing must take place to populate page numbers in the olink database.

insert.olink.pdf.frag
boolean

## insert.olink.pdf.frag

Add fragment identifiers for links into PDF files

    <xsl:param name="insert.olink.pdf.frag" select="0"></xsl:param>

### Description

The value of this parameter determines whether the cross reference URIs to PDF documents made with `olink` will include fragment identifiers.

When forming a URI to link to a PDF document, a fragment identifier (typically a '#' followed by an id value) appended to the PDF filename can be used by the PDF viewer to open the PDF file to a location within the document instead of the first page. However, not all PDF files have id values embedded in them, and not all PDF viewers can handle fragment identifiers.

If `insert.olink.pdf.frag` is set to a non-zero value, then any olink targeting a PDF file will have the fragment identifier appended to the URI. The URI is formed by concatenating the value of the `olink.base.uri` parameter, the value of the `baseuri` attribute from the `document` element in the olink database with the matching `targetdoc` value, and the value of the `href` attribute for the targeted element in the olink database. The `href` attribute contains the fragment identifier.

If `insert.olink.pdf.frag` is set to zero (the default value), then the `href` attribute from the olink database is not appended to PDF olinks, so the fragment identifier is left off. A PDF olink is any olink for which the `baseuri` attribute from the matching `document` element in the olink database ends with '.pdf'. Any other olinks will still have the fragment identifier added.

olink.base.uri
uri

## olink.base.uri

Base URI used in olink hrefs

    <xsl:param name="olink.base.uri"></xsl:param>

### Description

When cross reference data is collected for resolving olinks, it may be necessary to prepend a base URI to each target's href. This parameter lets you set that base URI when cross reference data is collected. This feature is needed when you want to link to a document that is processed without chunking. The output filename for such a document is not known to the XSL stylesheet; the only target information consists of fragment identifiers such as `#idref`. To enable the resolution of olinks between documents, you should pass the name of the HTML output file as the value of this parameter. Then the hrefs recorded in the cross reference data collection look like `outfile.html#idref`, which can be reached as links from other documents.

olink.debug
boolean

## olink.debug

Turn on debugging messages for olinks

    <xsl:param name="olink.debug" select="0"></xsl:param>

### Description

If non-zero, then each olink will generate several messages about how it is being resolved during processing. This is useful when an olink does not resolve properly and the standard error messages are not sufficient to find the problem.

You may need to read through the olink XSL templates to understand the context for some of the debug messages.

olink.doctitle
list
no
yes
maybe

## olink.doctitle

show the document title for external olinks?

    <xsl:param name="olink.doctitle">no</xsl:param>

### Description

When olinks between documents are resolved, the generated text may not make it clear that the reference is to another document. It is possible for the stylesheets to append the other document's title to external olinks. For this to happen, two parameters must be set.

- This `olink.doctitle` parameter should be set to either `yes` or `maybe` to enable this feature.

- And you should also set the `current.docid` parameter to the document id for the document currently being processed for output.

Then if an olink's `targetdoc` id differs from the `current.docid` value, the stylesheet knows that it is a reference to another document and can append the target document's title to the generated olink text.

The text for the target document's title is copied from the olink database from the `ttl` element of the top-level `div` for that document. If that `ttl` element is missing or empty, no title is output.

The supported values for `olink.doctitle` are:

`yes`

  Always insert the title to the target document if it is not the current document.

`no`

  Never insert the title to the target document, even if requested in an `xrefstyle` attribute.

`maybe`

  Only insert the title to the target document, if requested in an `xrefstyle` attribute.

An `xrefstyle` attribute may override the global setting for individual olinks. The following values are supported in an `xrefstyle` attribute using the `select:` syntax:

`docname`

  Insert the target document name for this olink using the `docname` gentext template, but only if the value of `olink.doctitle` is not `no`.

`docnamelong`

  Insert the target document name for this olink using the `docnamelong` gentext template, but only if the value of `olink.doctitle` is not `no`.

`nodocname`

  Omit the target document name even if the value of `olink.doctitle` is `yes`.

Another way of inserting the target document name for a single olink is to employ an `xrefstyle` attribute using the `template:` syntax. The `%o` placeholder (the letter o, not zero) in such a template will be filled in with the target document's title when it is processed. This will occur regardless of the value of `olink.doctitle`.

Note that prior to version 1.66 of the XSL stylesheets, the allowed values for this parameter were 0 and 1. Those values are still supported and mapped to 'no' and 'yes', respectively.

olink.lang.fallback.sequence
string

## olink.lang.fallback.sequence

look up translated documents if olink not found?

    <xsl:param name="olink.lang.fallback.sequence"></xsl:param>

### Description

This parameter defines a list of lang values to search among to resolve olinks.

Normally an olink tries to resolve to a document in the same language as the olink itself. The language of an olink is determined by its nearest ancestor element with a `lang` attribute, otherwise the value of the `l10n.gentext.default.lang` parameter.

An olink database can contain target data for the same document in multiple languages. Each set of data has the same value for the `targetdoc` attribute in the `document` element in the database, but with a different `lang` attribute value.

When an olink is being resolved, the target is first sought in the document with the same language as the olink. If no match is found there, then this parameter is consulted for additional languages to try.

The `olink.lang.fallback.sequence` must be a whitespace separated list of lang values to try. The first one with a match in the olink database is used. The default value is empty.

For example, a document might be written in German and contain an olink with `targetdoc="adminguide"`. When the document is processed, the processor first looks for a target dataset in the olink database starting with:

    <document targetdoc="adminguide" lang="de">.

If there is no such element, then the `olink.lang.fallback.sequence` parameter is consulted. If its value is, for example, fr en, then the processor next looks for `targetdoc="adminguide" lang="fr"`, and then for `targetdoc="adminguide" lang="en"`. If there is still no match, it looks for `targetdoc="adminguide"` with no lang attribute.

This parameter is useful when a set of documents is only partially translated, or is in the process of being translated. If a target of an olink has not yet been translated, then this parameter permits the processor to look for the document in other languages. This assumes the reader would rather have a link to a document in a different language than to have a broken link.

olink.properties
attribute set

## olink.properties

Properties associated with the cross-reference text of an olink.

    <xsl:attribute-set name="olink.properties">
      <xsl:attribute name="show-destination">replace</xsl:attribute>
    </xsl:attribute-set>

### Description

This `attribute set` is applied to the `fo:basic-link` element of an olink. It is not applied to the optional page number or optional title of the external document.

prefer.internal.olink
boolean

## prefer.internal.olink

Prefer a local olink reference to an external reference

    <xsl:param name="prefer.internal.olink" select="0"></xsl:param>

### Description

If you are re-using XML content modules in multiple documents, you may want to redirect some of your olinks. This parameter permits you to redirect an olink to the current document.

For example: you are writing documentation for a product, which includes 3 manuals: a little installation booklet (booklet.xml), a user guide (user.xml), and a reference manual (reference.xml). All 3 documents begin with the same introduction section (intro.xml) that contains a reference to the customization section (custom.xml) which is included in both user.xml and reference.xml documents.

How do you write the link to custom.xml in intro.xml so that it is interpreted correctly in all 3 documents?

- If you use xref, it will fail in user.xml.

- If you use olink (pointing to reference.xml), the reference in user.xml will point to the customization section of the reference manual, while it is actually available in user.xml.

If you set the `prefer.internal.olink` parameter to a non-zero value, then the processor will first look in the olink database for the olink's `targetptr` attribute value in document matching the `current.docid` parameter value. If it isn't found there, then it tries the document in the database with the `targetdoc` value that matches the olink's `targetdoc` attribute.

This feature permits an olink reference to resolve to the current document if there is an element with an id matching the olink's `targetptr` value. The current document's olink data must be included in the target database for this to work.

There is a potential for incorrect links if the same `id` attribute value is used for different content in different documents. Some of your olinks may be redirected to the current document when they shouldn't be. It is not possible to control individual olink instances.

target.database.document
uri

## target.database.document

Name of master database file for resolving olinks

     <xsl:param name="target.database.document">olinkdb.xml</xsl:param>

### Description

To resolve olinks between documents, the stylesheets use a master database document that identifies the target datafiles for all the documents within the scope of the olinks. This parameter value is the URI of the master document to be read during processing to resolve olinks. The default value is `olinkdb.xml`.

The data structure of the file is defined in the `targetdatabase.dtd` DTD. The database file provides the high level elements to record the identifiers, locations, and relationships of documents. The cross reference data for individual documents is generally pulled into the database using system entity references or XIncludes. See also `targets.filename`.

targets.filename
string

## targets.filename

Name of cross reference targets data file

    <xsl:param name="targets.filename">target.db</xsl:param>

### Description

In order to resolve olinks efficiently, the stylesheets can generate an external data file containing information about all potential cross reference endpoints in a document. This parameter lets you change the name of the generated file from the default name `target.db`. The name must agree with that used in the target database used to resolve olinks during processing. See also `target.database.document`.

use.local.olink.style
boolean

## use.local.olink.style

Process olinks using xref style of current document

    <xsl:param name="use.local.olink.style" select="0"></xsl:param>

### Description

When cross reference data is collected for use by olinks, the data for each potential target includes one field containing a completely assembled cross reference string, as if it were an xref generated in that document. Other fields record the separate title, number, and element name of each target. When an olink is formed to a target from another document, the olink resolves to that preassembled string by default. If the `use.local.olink.style` parameter is set to non-zero, then instead the cross reference string is formed again from the target title, number, and element name, using the stylesheet processing the targeting document. Then olinks will match the xref style in the targeting document rather than in the target document. If both documents are processed with the same stylesheet, then the results will be the same.

## Cross References

insert.xref.page.number
list
no
yes
maybe

## insert.xref.page.number

Turns page numbers in xrefs on and off

    <xsl:param name="insert.xref.page.number">no</xsl:param>

### Description

The value of this parameter determines if cross references (`xref`s) in printed output will include page number citations. It has three possible values.

no

  No page number references will be generated.

yes

  Page number references will be generated for all `xref` elements. The style of page reference may be changed if an `xrefstyle` attribute is used.

maybe

  Page number references will not be generated for an `xref` element unless it has an `xrefstyle` attribute whose value specifies a page reference.

xref.properties
attribute set

## xref.properties

Properties associated with cross-reference text

    <xsl:attribute-set name="xref.properties">
    </xsl:attribute-set>

### Description

This attribute set is used to set properties on cross reference text.

xref.label-title.separator
string

## xref.label-title.separator

Punctuation or space separating label from title in xref

    <xsl:param name="xref.label-title.separator">: </xsl:param>

### Description

This parameter allows you to control the punctuation of certain types of generated cross reference text. When cross reference text is generated for an `xref` or `olink` element using an `xrefstyle` attribute that makes use of the `select:` feature, and the selected components include both label and title, then the value of this parameter is inserted between label and title in the output.

xref.label-page.separator
string

## xref.label-page.separator

Punctuation or space separating label from page number in xref

    <xsl:param name="xref.label-page.separator"><xsl:text> </xsl:text></xsl:param>

### Description

This parameter allows you to control the punctuation of certain types of generated cross reference text. When cross reference text is generated for an `xref` or `olink` element using an `xrefstyle` attribute that makes use of the `select:` feature, and the selected components include both label and page but no title, then the value of this parameter is inserted between label and page number in the output. If a title is included, then other separators are used.

xref.title-page.separator
string

## xref.title-page.separator

Punctuation or space separating title from page number in xref

    <xsl:param name="xref.title-page.separator"><xsl:text> </xsl:text></xsl:param>

### Description

This parameter allows you to control the punctuation of certain types of generated cross reference text. When cross reference text is generated for an `xref` or `olink` element using an `xrefstyle` attribute that makes use of the `select:` feature, and the selected components include both title and page number, then the value of this parameter is inserted between title and page number in the output.

insert.link.page.number
list
no
yes
maybe

## insert.link.page.number

Turns page numbers in link elements on and off

    <xsl:param name="insert.link.page.number">no</xsl:param>

### Description

The value of this parameter determines if cross references using the `link` element in printed output will include standard page number citations. It has three possible values.

no

  No page number references will be generated.

yes

  Page number references will be generated for all `link` elements. The style of page reference may be changed if an `xrefstyle` attribute is used.

maybe

  Page number references will not be generated for a `link` element unless it has an `xrefstyle` attribute whose value specifies a page reference.

Although the `xrefstyle` attribute can be used to turn the page reference on or off, it cannot be used to control the formatting of the page number as it can in `xref`. In `link` it will always format with the style established by the gentext template with `name="page.citation"` in the `l:context name="xref"`.

## Lists

compact.list.item.spacing
attribute set

## compact.list.item.spacing

What space do you want between list items (when spacing="compact")?

    <xsl:attribute-set name="compact.list.item.spacing">
      <xsl:attribute name="space-before.optimum">0em</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">0.2em</xsl:attribute>
    </xsl:attribute-set>

### Description

Specify what spacing you want between each list item when `spacing` is `compact`.

itemizedlist.properties
attribute set

## itemizedlist.properties

Properties that apply to each list-block generated by itemizedlist.

    <xsl:attribute-set name="itemizedlist.properties" use-attribute-sets="list.block.properties">
    </xsl:attribute-set>

### Description

Properties that apply to each fo:list-block generated by itemizedlist.

itemizedlist.label.properties
attribute set

## itemizedlist.label.properties

Properties that apply to each label inside itemized list.

    <xsl:attribute-set name="itemizedlist.label.properties">
    </xsl:attribute-set>

### Description

Properties that apply to each label inside itemized list. E.g.:

    <xsl:attribute-set name="itemizedlist.label.properties">
      <xsl:attribute name="text-align">right</xsl:attribute>
    </xsl:attribute-set>

itemizedlist.label.width
length

## itemizedlist.label.width

The default width of the label (bullet) in an itemized list.

        <xsl:param name="itemizedlist.label.width">1.0em</xsl:param>

### Description

Specifies the default width of the label (usually a bullet or other symbol) in an itemized list. You can override the default value on any particular list with the “dbfo” processing instruction using the “label-width” pseudoattribute.

list.block.properties
attribute set

## list.block.properties

Properties that apply to each list-block generated by list.

    <xsl:attribute-set name="list.block.properties">
      <xsl:attribute name="provisional-label-separation">0.2em</xsl:attribute>
      <xsl:attribute name="provisional-distance-between-starts">1.5em</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties that apply to each fo:list-block generated by itemizedlist/orderedlist.

list.block.spacing
attribute set

## list.block.spacing

What spacing do you want before and after lists?

    <xsl:attribute-set name="list.block.spacing">
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">1.2em</xsl:attribute>
    </xsl:attribute-set>

### Description

Specify the spacing required before and after a list. It is necessary to specify the space after a list block because lists can come inside of paras.

list.item.spacing
attribute set

## list.item.spacing

What space do you want between list items?

    <xsl:attribute-set name="list.item.spacing">
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
    </xsl:attribute-set>

### Description

Specify what spacing you want between each list item.

orderedlist.properties
attribute set

## orderedlist.properties

Properties that apply to each list-block generated by orderedlist.

    <xsl:attribute-set name="orderedlist.properties" use-attribute-sets="list.block.properties">
      <xsl:attribute name="provisional-distance-between-starts">2em</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties that apply to each fo:list-block generated by orderedlist.

orderedlist.label.properties
attribute set

## orderedlist.label.properties

Properties that apply to each label inside ordered list.

    <xsl:attribute-set name="orderedlist.label.properties">
    </xsl:attribute-set>

### Description

Properties that apply to each label inside ordered list. E.g.:

    <xsl:attribute-set name="orderedlist.label.properties">
      <xsl:attribute name="text-align">right</xsl:attribute>
    </xsl:attribute-set>

orderedlist.label.width
length

## orderedlist.label.width

The default width of the label (number) in an ordered list.

    <xsl:param name="orderedlist.label.width">1.2em</xsl:param>

### Description

Specifies the default width of the label (usually a number or sequence of numbers) in an ordered list. You can override the default value on any particular list with the “dbfo” processing instruction using the “label-width” pseudoattribute.

variablelist.max.termlength
number

## variablelist.max.termlength

Specifies the longest term in variablelists

    <xsl:param name="variablelist.max.termlength">24</xsl:param>

### Description

In variablelists, the `listitem` is indented to leave room for the `term` elements. That indent may be computed if it is not specified with a `termlength` attribute on the `variablelist` element.

The computation counts characters in the `term` elements in the list to find the longest term. However, some terms are very long and would produce extreme indents. This parameter lets you set a maximum character count. Any terms longer than the maximum would line wrap. The default value is 24.

The character counts are converted to physical widths by multiplying by 0.50em. There will be some variability in how many actual characters fit in the space since some characters are wider than others.

variablelist.term.separator
string

## variablelist.term.separator

Text to separate `term`s within a multi-term `varlistentry`

    <xsl:param name="variablelist.term.separator">, </xsl:param>

### Description

When a `varlistentry` contains multiple `term` elements, the string specified in the value of the `variablelist.term.separator` parameter is placed after each `term` except the last.

To generate a line break between multiple `term`s in a `varlistentry`, set a non-zero value for the `variablelist.term.break.after` parameter. If you do so, you may also want to set the value of the `variablelist.term.separator` parameter to an empty string (to suppress rendering of the default comma and space after each `term`).

variablelist.term.properties
attribute set

## variablelist.term.properties

To add properties to the term elements in a variablelist.

    <xsl:attribute-set name="variablelist.term.properties">
    </xsl:attribute-set>

### Description

These properties are added to the block containing a term in a variablelist. Use this attribute-set to set font properties or alignment, for example.

variablelist.term.break.after
boolean

## variablelist.term.break.after

Generate line break after each `term` within a multi-term `varlistentry`?

    <xsl:param name="variablelist.term.break.after">0</xsl:param>

### Description

Set a non-zero value for the `variablelist.term.break.after` parameter to generate a line break between `term`s in a multi-term `varlistentry`.

If you set a non-zero value for `variablelist.term.break.after`, you may also want to set the value of the `variablelist.term.separator` parameter to an empty string (to suppress rendering of the default comma and space after each `term`).

## QAndASet

qandadiv.autolabel
boolean

## qandadiv.autolabel

Are divisions in QAndASets enumerated?

    <xsl:param name="qandadiv.autolabel" select="1"></xsl:param>

### Description

If non-zero, unlabeled qandadivs will be enumerated.

qanda.inherit.numeration
boolean

## qanda.inherit.numeration

Does enumeration of QandASet components inherit the numeration of parent elements?

    <xsl:param name="qanda.inherit.numeration" select="1"></xsl:param>

### Description

If non-zero, numbered `qandadiv` elements and `question` and `answer` inherit the enumeration of the ancestors of the `qandaset`.

qanda.defaultlabel
list
number
qanda
none

## qanda.defaultlabel

Sets the default for defaultlabel on QandASet.

    <xsl:param name="qanda.defaultlabel">number</xsl:param>

### Description

If no `defaultlabel` attribute is specified on a `qandaset`, this value is used. It is generally one of the legal values for the defaultlabel attribute (`none`, `number` or `qanda`), or one of the additional stylesheet-specific values (`qnumber` or `qnumberanda`). The default value is 'number'.

The values are rendered as follows:

`qanda`

  `question`s are labeled "Q:" and `answer`s are labeled "A:".

`number`

  The questions are enumerated and the answers are not labeled.

`qnumber`

  The questions are labeled "Q:" followed by a number, and answers are not labeled. When sections are numbered, adding a label to the number distinguishes the question numbers from the section numbers. This value is not allowed in the `defaultlabel` attribute of a `qandaset` element.

`qnumberanda`

  The questions are labeled "Q:" followed by a number, and the answers are labeled "A:". When sections are numbered, adding a label to the number distinguishes the question numbers from the section numbers. This value is not allowed in the `defaultlabel` attribute of a `qandaset` element.

`none`

  No distinguishing label precedes Questions or Answers.

qanda.in.toc
boolean

## qanda.in.toc

Should qandaentry questions appear in the document table of contents?

    <xsl:param name="qanda.in.toc" select="0"></xsl:param>

### Description

If true (non-zero), then the generated table of contents for a document will include `qandaset` titles, `qandadiv` titles, and `question` elements. The default value (zero) excludes them from the TOC.

This parameter does not affect any tables of contents that may be generated inside a qandaset or qandadiv.

qanda.nested.in.toc
boolean

## qanda.nested.in.toc

Should nested answer/qandaentry instances appear in TOC?

    <xsl:param name="qanda.nested.in.toc" select="0"></xsl:param>

### Description

If non-zero, instances of `qandaentry` that are children of `answer` elements are shown in the TOC.

## Bibliography

bibliography.style
list
normal
iso690

## bibliography.style

Style used for formatting of biblioentries.

    <xsl:param name="bibliography.style">normal</xsl:param>

### Description

Currently only `normal` and `iso690` styles are supported.

In order to use ISO690 style to the full extent you might need to use additional markup described on the following WiKi page.

biblioentry.item.separator
string

## biblioentry.item.separator

Text to separate bibliography entries

    <xsl:param name="biblioentry.item.separator">. </xsl:param>

### Description

Text to separate bibliography entries

bibliography.collection
string

## bibliography.collection

Name of the bibliography collection file

    <xsl:param name="bibliography.collection">http://docbook.sourceforge.net/release/bibliography/bibliography.xml</xsl:param>

### Description

Maintaining bibliography entries across a set of documents is tedious, time consuming, and error prone. It makes much more sense, usually, to store all of the bibliography entries in a single place and simply extract the ones you need in each document.

That's the purpose of the `bibliography.collection` parameter. To setup a global bibliography database, follow these steps:

First, create a stand-alone bibliography document that contains all of the documents that you wish to reference. Make sure that each bibliography entry (whether you use `biblioentry` or `bibliomixed`) has an ID.

My global bibliography, `~/bibliography.xml` begins like this:

    <!DOCTYPE bibliography
      PUBLIC "-//OASIS//DTD DocBook XML V4.1.2//EN"
      "http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd">
    <bibliography><title>References</title>

    <bibliomixed id="xml-rec"><abbrev>XML 1.0</abbrev>Tim Bray,
    Jean Paoli, C. M. Sperberg-McQueen, and Eve Maler, editors.
    <citetitle><ulink url="http://www.w3.org/TR/REC-xml">Extensible Markup
    Language (XML) 1.0 Second Edition</ulink></citetitle>.
    World Wide Web Consortium, 2000.
    </bibliomixed>

    <bibliomixed id="xml-names"><abbrev>Namespaces</abbrev>Tim Bray,
    Dave Hollander,
    and Andrew Layman, editors.
    <citetitle><ulink url="http://www.w3.org/TR/REC-xml-names/">Namespaces in
    XML</ulink></citetitle>.
    World Wide Web Consortium, 1999.
    </bibliomixed>

    <!-- ... -->
    </bibliography>

When you create a bibliography in your document, simply provide empty `bibliomixed` entries for each document that you wish to cite. Make sure that these elements have the same ID as the corresponding real entry in your global bibliography.

For example:

    <bibliography><title>Bibliography</title>

    <bibliomixed id="xml-rec"/>
    <bibliomixed id="xml-names"/>
    <bibliomixed id="DKnuth86">Donald E. Knuth. <citetitle>Computers and
    Typesetting: Volume B, TeX: The Program</citetitle>. Addison-Wesley,
    1986.  ISBN 0-201-13437-3.
    </bibliomixed>
    <bibliomixed id="relaxng"/>

    </bibliography>

Note that it's perfectly acceptable to mix entries from your global bibliography with normal entries. You can use `xref` or other elements to cross-reference your bibliography entries in exactly the same way you do now.

Finally, when you are ready to format your document, simply set the `bibliography.collection` parameter (in either a customization layer or directly through your processor's interface) to point to your global bibliography.

The stylesheets will format the bibliography in your document as if all of the entries referenced appeared there literally.

bibliography.numbered
boolean

## bibliography.numbered

Should bibliography entries be numbered?

    <xsl:param name="bibliography.numbered" select="0"></xsl:param>

### Description

If non-zero bibliography entries will be numbered

biblioentry.properties
attribute set

## biblioentry.properties

To set the style for biblioentry.

    <xsl:attribute-set name="biblioentry.properties" use-attribute-sets="normal.para.spacing">
      <xsl:attribute name="start-indent">0.5in</xsl:attribute>
      <xsl:attribute name="text-indent">-0.5in</xsl:attribute>
    </xsl:attribute-set>

### Description

How do you want biblioentry styled?

Set the font-size, weight, space-above and space-below, indents, etc. to the style required

## Glossary

glossterm.auto.link
boolean

## glossterm.auto.link

Generate links from glossterm to glossentry automatically?

    <xsl:param name="glossterm.auto.link" select="0"></xsl:param>

### Description

If non-zero, links from inline `glossterm`s to the corresponding `glossentry` elements in a `glossary` or `glosslist` will be automatically generated. This is useful when your glossterms are consistent and you don't want to add links manually.

The automatic link generation feature is not used on `glossterm` elements that have a `linkend` attribute.

firstterm.only.link
boolean

## firstterm.only.link

Does automatic glossterm linking only apply to firstterms?

    <xsl:param name="firstterm.only.link" select="0"></xsl:param>

### Description

If non-zero, only `firstterm`s will be automatically linked to the glossary. If glossary linking is not enabled, this parameter has no effect.

glossary.collection
string

## glossary.collection

Name of the glossary collection file

    <xsl:param name="glossary.collection"></xsl:param>

### Description

Glossaries maintained independently across a set of documents are likely to become inconsistent unless considerable effort is expended to keep them in sync. It makes much more sense, usually, to store all of the glossary entries in a single place and simply extract the ones you need in each document.

That's the purpose of the `glossary.collection` parameter. To setup a global glossary database, follow these steps:

#### Setting Up the Glossary Database

First, create a stand-alone glossary document that contains all of the entries that you wish to reference. Make sure that each glossary entry has an ID.

Here's an example glossary:

    <?xml version="1.0" encoding="utf-8"?>
    <!DOCTYPE glossary
      PUBLIC "-//OASIS//DTD DocBook XML V4.1.2//EN"
      "http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd">
    <glossary>
    <glossaryinfo>
    <editor><firstname>Eric</firstname><surname>Raymond</surname></editor>
    <title>Jargon File 4.2.3 (abridged)</title>
    <releaseinfo>Just some test data</releaseinfo>
    </glossaryinfo>

    <glossdiv><title>0</title>

    <glossentry>
    <glossterm>0</glossterm>
    <glossdef>
    <para>Numeric zero, as opposed to the letter `O' (the 15th letter of
    the English alphabet). In their unmodified forms they look a lot
    alike, and various kluges invented to make them visually distinct have
    compounded the confusion. If your zero is center-dotted and letter-O
    is not, or if letter-O looks almost rectangular but zero looks more
    like an American football stood on end (or the reverse), you're
    probably looking at a modern character display (though the dotted zero
    seems to have originated as an option on IBM 3270 controllers). If
    your zero is slashed but letter-O is not, you're probably looking at
    an old-style ASCII graphic set descended from the default typewheel on
    the venerable ASR-33 Teletype (Scandinavians, for whom /O is a letter,
    curse this arrangement). (Interestingly, the slashed zero long
    predates computers; Florian Cajori's monumental "A History of
    Mathematical Notations" notes that it was used in the twelfth and
    thirteenth centuries.) If letter-O has a slash across it and the zero
    does not, your display is tuned for a very old convention used at IBM
    and a few other early mainframe makers (Scandinavians curse <emphasis>this</emphasis>
    arrangement even more, because it means two of their letters collide).
    Some Burroughs/Unisys equipment displays a zero with a <emphasis>reversed</emphasis>
    slash. Old CDC computers rendered letter O as an unbroken oval and 0
    as an oval broken at upper right and lower left. And yet another
    convention common on early line printers left zero unornamented but
    added a tail or hook to the letter-O so that it resembled an inverted
    Q or cursive capital letter-O (this was endorsed by a draft ANSI
    standard for how to draw ASCII characters, but the final standard
    changed the distinguisher to a tick-mark in the upper-left corner).
    Are we sufficiently confused yet?</para>
    </glossdef>
    </glossentry>

    <glossentry>
    <glossterm>1TBS</glossterm>
    <glossdef>
    <para role="accidence">
    <phrase role="pronounce"></phrase>
    <phrase role="partsofspeach">n</phrase>
    </para>
    <para>The "One True Brace Style"</para>
    <glossseealso>indent style</glossseealso>
    </glossdef>
    </glossentry>

    <!-- ... -->

    </glossdiv>

    <!-- ... -->

    </glossary>

#### Marking Up Glossary Terms

That takes care of the glossary database, now you have to get the entries into your document. Unlike bibliography entries, which can be empty, creating placeholder glossary entries would be very tedious. So instead, support for `glossary.collection` relies on implicit linking.

In your source document, simply use `firstterm` and `glossterm` to identify the terms you wish to have included in the glossary. The stylesheets assume that you will either set the `baseform` attribute correctly, or that the content of the element exactly matches a term in your glossary.

If you're using a `glossary.collection`, don't make explicit links on the terms in your document.

So, in your document, you might write things like this:

    <para>This is dummy text, without any real meaning.
    The point is simply to reference glossary terms like <glossterm>0</glossterm>
    and the <firstterm baseform="1TBS">One True Brace Style (1TBS)</firstterm>.
    The <glossterm>1TBS</glossterm>, as you can probably imagine, is a nearly
    religious issue.</para>

If you set the `firstterm.only.link` parameter, only the terms marked with `firstterm` will be links. Otherwise, all the terms will be linked.

#### Marking Up the Glossary

The glossary itself has to be identified for the stylesheets. For lack of a better choice, the `role` is used. To identify the glossary as the target for automatic processing, set the role to `auto`. The title of this glossary (and any other information from the `glossaryinfo` that's rendered by your stylesheet) will be displayed, but the entries will come from the database.

Unfortunately, the glossary can't be empty, so you must put in at least one `glossentry`. The content of this entry is irrelevant, it will not be rendered:

    <glossary role="auto">
    <glossentry>
    <glossterm>Irrelevant</glossterm>
    <glossdef>
    <para>If you can see this, the document was processed incorrectly. Use
    the <parameter>glossary.collection</parameter> parameter.</para>
    </glossdef>
    </glossentry>
    </glossary>

What about glossary divisions? If your glossary database has glossary divisions and your automatic glossary contains at least one `glossdiv`, the automic glossary will have divisions. If the `glossdiv` is missing from either location, no divisions will be rendered.

Glossary entries (and divisions, if appropriate) in the glossary will occur in precisely the order they occur in your database.

#### Formatting the Document

Finally, when you are ready to format your document, simply set the `glossary.collection` parameter (in either a customization layer or directly through your processor's interface) to point to your global glossary.

The stylesheets will format the glossary in your document as if all of the entries implicilty referenced appeared there literally.

#### Limitations

Glossary cross-references within the glossary are not supported. For example, this will not work:

    <glossentry>
    <glossterm>gloss-1</glossterm>
    <glossdef><para>A description that references <glossterm>gloss-2</glossterm>.</para>
    <glossseealso>gloss-2</glossseealso>
    </glossdef>
    </glossentry>

If you put glossary cross-references in your glossary that way, you'll get the cryptic error: `Warning: glossary.collection specified, but there are 0 automatic glossaries`.

Instead, you must do two things:

1. Markup your glossary using `glossseealso`:

       <glossentry>
       <glossterm>gloss-1</glossterm>
       <glossdef><para>A description that references <glossterm>gloss-2</glossterm>.</para>
       <glossseealso>gloss-2</glossseealso>
       </glossdef>
       </glossentry>

2. Make sure there is at least one `glossterm` reference to gloss-2 in your document. The easiest way to do that is probably within a `remark` in your automatic glossary:

       <glossary role="auto">
       <remark>Make sure there's a reference to <glossterm>gloss-2</glossterm>.</remark>
       <glossentry>
       <glossterm>Irrelevant</glossterm>
       <glossdef>
       <para>If you can see this, the document was processed incorrectly. Use
       the <parameter>glossary.collection</parameter> parameter.</para>
       </glossdef>
       </glossentry>
       </glossary>

glossary.as.blocks
boolean

## glossary.as.blocks

Present glossarys using blocks instead of lists?

    <xsl:param name="glossary.as.blocks" select="0"></xsl:param>

### Description

If non-zero, `glossary`s will be formatted as blocks.

If you have long `glossterm`s, proper list markup in the FO case may produce unattractive lists. By setting this parameter, you can force the stylesheets to produce block markup instead of proper lists.

You can override this setting with a processing instruction as the child of `glossary`: `dbfo glossary-presentation="blocks"` or `dbfo glossary-presentation="list"`

glosslist.as.blocks
boolean

## glosslist.as.blocks

Use blocks for glosslists?

    <xsl:param name="glosslist.as.blocks" select="0"></xsl:param>

### Description

See `glossary.as.blocks`.

glossentry.list.item.properties
attribute set

## glossentry.list.item.properties

To add properties to each glossentry in a list.

    <xsl:attribute-set name="glossentry.list.item.properties">
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
    </xsl:attribute-set>

### Description

These properties are added to the fo:list-item containing a glossentry in a glossary when the `glossary.as.blocks` parameter is zero. Use this attribute-set to set spacing between entries, for example.

glossterm.block.properties
attribute set

## glossterm.block.properties

To add properties to the block of a glossentry's glossterm.

    <xsl:attribute-set name="glossterm.block.properties">
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
    </xsl:attribute-set>

### Description

These properties are added to the block containing a glossary term in a glossary when the `glossary.as.blocks` parameter is non-zero. Use this attribute-set to set the space above and below, font properties, and any indent for the glossary term.

glossdef.block.properties
attribute set

## glossdef.block.properties

To add properties to the block of a glossary definition.

    <xsl:attribute-set name="glossdef.block.properties">
      <xsl:attribute name="margin-{$direction.align.start}">.25in</xsl:attribute>
    </xsl:attribute-set>

### Description

These properties are added to the block containing a glossary definition in a glossary when the `glossary.as.blocks` parameter is non-zero. Use this attribute-set to set the space above and below, any font properties, and any indent for the glossary definition.

glossterm.list.properties
attribute set

## glossterm.list.properties

To add properties to the glossterm in a list.

    <xsl:attribute-set name="glossterm.list.properties">
    </xsl:attribute-set>

### Description

These properties are added to the block containing a glossary term in a glossary when the `glossary.as.blocks` parameter is zero. Use this attribute-set to set font properties, for example.

glossdef.list.properties
attribute set

## glossdef.list.properties

To add properties to the glossary definition in a list.

    <xsl:attribute-set name="glossdef.list.properties">
    </xsl:attribute-set>

### Description

These properties are added to the block containing a glossary definition in a glossary when the `glossary.as.blocks` parameter is zero. Use this attribute-set to set font properties, for example.

glossterm.width
length

## glossterm.width

Width of glossterm in list presentation mode

    <xsl:param name="glossterm.width">2in</xsl:param>

### Description

This parameter specifies the width reserved for glossary terms when a list presentation is used.

glossterm.separation
length

## glossterm.separation

Separation between glossary terms and descriptions in list mode

    <xsl:param name="glossterm.separation">0.25in</xsl:param>

### Description

Specifies the miminum horizontal separation between glossary terms and descriptions when they are presented side-by-side using lists when the `glossary.as.blocks` is zero.

glossentry.show.acronym
list
no
yes
primary

## glossentry.show.acronym

Display `glossentry` acronyms?

    <xsl:param name="glossentry.show.acronym">no</xsl:param>

### Description

A setting of yes means they should be displayed; no means they shouldn't. If primary is used, then they are shown as the primary text for the entry.

This setting controls both `acronym` and `abbrev` elements in the `glossentry`.

glossary.sort
boolean

## glossary.sort

Sort glossentry elements?

    <xsl:param name="glossary.sort" select="0"></xsl:param>

### Description

If non-zero, then the glossentry elements within a glossary, glossdiv, or glosslist are sorted on the glossterm, using the current lang setting. If zero (the default), then glossentry elements are not sorted and are presented in document order.

## Miscellaneous

formal.procedures
boolean

## formal.procedures

Selects formal or informal procedures

    <xsl:param name="formal.procedures" select="1"></xsl:param>

### Description

Formal procedures are numbered and always have a title.

formal.title.placement
table

## formal.title.placement

Specifies where formal object titles should occur

    <xsl:param name="formal.title.placement">
    figure before
    example before
    equation before
    table before
    procedure before
    task before
    </xsl:param>

### Description

Specifies where formal object titles should occur. For each formal object type (`figure`, `example`, `equation`, `table`, and `procedure`) you can specify either the keyword `before` or `after`.

runinhead.default.title.end.punct
string

## runinhead.default.title.end.punct

Default punctuation character on a run-in-head

    <xsl:param name="runinhead.default.title.end.punct">.</xsl:param>

### Description

If non-zero, For a `formalpara`, use the specified string as the separator between the title and following text. The period is the default value.

runinhead.title.end.punct
string

## runinhead.title.end.punct

Characters that count as punctuation on a run-in-head

    <xsl:param name="runinhead.title.end.punct">.!?:</xsl:param>

### Description

Specify which characters are to be counted as punctuation. These characters are checked for a match with the last character of the title. If no match is found, the `runinhead.default.title.end.punct` contents are inserted. This is to avoid duplicated punctuation in the output.

show.comments
boolean

## show.comments

Display `remark` elements?

    <xsl:param name="show.comments" select="1"></xsl:param>

### Description

If non-zero, comments will be displayed, otherwise they are suppressed. Comments here refers to the `remark` element (which was called `comment` prior to DocBook 4.0), not XML comments (<-- like this -->) which are unavailable.

punct.honorific
string

## punct.honorific

Punctuation after an honorific in a personal name.

    <xsl:param name="punct.honorific">.</xsl:param>

### Description

This parameter specifies the punctuation that should be added after an honorific in a personal name.

segmentedlist.as.table
boolean

## segmentedlist.as.table

Format segmented lists as tables?

    <xsl:param name="segmentedlist.as.table" select="0"></xsl:param>

### Description

If non-zero, `segmentedlist`s will be formatted as tables.

variablelist.as.blocks
boolean

## variablelist.as.blocks

Format `variablelist`s lists as blocks?

    <xsl:param name="variablelist.as.blocks" select="0"></xsl:param>

### Description

If non-zero, `variablelist`s will be formatted as blocks.

If you have long terms, proper list markup in the FO case may produce unattractive lists. By setting this parameter, you can force the stylesheets to produce block markup instead of proper lists.

You can override this setting with a processing instruction as the child of `variablelist`: `dbfo list-presentation="blocks"` or `dbfo list-presentation="list"`.

When using `list-presentation="list"`, you can also control the amount of space used for the `term`s with the `dbfo term-width=".25in"` processing instruction, the `termlength` attribute on `variablelist`, or allow the stylesheets to attempt to calculate the amount of space to leave based on the number of letters in the longest term.

      <variablelist>
            <?dbfo list-presentation="list"?>
            <?dbfo term-width="1.5in"?>
            <?dbhtml list-presentation="table"?>
            <?dbhtml term-width="1.5in"?>
            <varlistentry>
              <term>list</term>
              <listitem>
                    <para>
                      Formatted as a list even if variablelist.as.blocks is set to 1.
                    </para>
              </listitem>
            </varlistentry>
      </variablelist>

blockquote.properties
attribute set

## blockquote.properties

To set the style for block quotations.

    <xsl:attribute-set name="blockquote.properties">
    <xsl:attribute name="margin-{$direction.align.start}">0.5in</xsl:attribute>
    <xsl:attribute name="margin-{$direction.align.end}">0.5in</xsl:attribute>
    <xsl:attribute name="space-after.minimum">0.5em</xsl:attribute>
    <xsl:attribute name="space-after.optimum">1em</xsl:attribute>
    <xsl:attribute name="space-after.maximum">2em</xsl:attribute>
    </xsl:attribute-set>

### Description

The `blockquote.properties` attribute set specifies the formating properties of block quotations.

ulink.show
boolean

## ulink.show

Display URLs after `ulink`s?

    <xsl:param name="ulink.show" select="1"></xsl:param>

### Description

If non-zero, the URL of each `ulink` will appear after the text of the link. If the text of the link and the URL are identical, the URL is suppressed.

See also `ulink.footnotes`.

DocBook 5 does not have an `ulink` element. When processing DocBoook 5 documents, `ulink.show` applies to all inline elements that are marked up with `xlink:href` attributes that point to external resources.

ulink.footnotes
boolean

## ulink.footnotes

Generate footnotes for `ulink`s?

    <xsl:param name="ulink.footnotes" select="0"></xsl:param>

### Description

If non-zero, and if `ulink.show` also is non-zero, the URL of each `ulink` will appear as a footnote.

DocBook 5 does not have an `ulink` element. When processing DocBoook 5 documents, `ulink.footnotes` applies to all inline elements that are marked up with `xlink:href` attributes that point to external resources.

ulink.hyphenate
string

## ulink.hyphenate

Allow URLs to be automatically hyphenated

    <xsl:param name="ulink.hyphenate"></xsl:param>

### Description

If not empty, the specified character (or more generally, content) is added to URLs after every character included in the string in the `ulink.hyphenate.chars` parameter (default is /). If the character in this parameter is a Unicode soft hyphen (0x00AD) or Unicode zero-width space (0x200B), some FO processors will be able to reasonably hyphenate long URLs.

As of 28 Jan 2002, discretionary hyphens are more widely and correctly supported than zero-width spaces for this purpose.

ulink.hyphenate.chars
string

## ulink.hyphenate.chars

List of characters to allow ulink URLs to be automatically hyphenated on

    <xsl:param name="ulink.hyphenate.chars">/</xsl:param>

### Description

If the `ulink.hyphenate` is not empty, then hyphenation of ulinks is turned on, and any character contained in this parameter is treated as an allowable hyphenation point.

The default value is /, but the parameter could be customized to contain other URL characters, as for example:

    <xsl:param name="ulink.hyphenate.chars">:/@&?.#</xsl:param>

shade.verbatim
boolean

## shade.verbatim

Should verbatim environments be shaded?

    <xsl:param name="shade.verbatim" select="0"></xsl:param>

### Description

In the FO stylesheet, if this parameter is non-zero then the shade.verbatim.style properties will be applied to verbatim environments.

In the HTML stylesheet, this parameter is now deprecated. Use CSS instead.

shade.verbatim.style
attribute set

## shade.verbatim.style

Properties that specify the style of shaded verbatim listings

    <xsl:attribute-set name="shade.verbatim.style">
      <xsl:attribute name="background-color">#E0E0E0</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties that specify the style of shaded verbatim listings. The parameters specified (the border and background color) are added to the styling of the xsl-fo output. A border might be specified as "thin black solid" for example. See xsl-fo

hyphenate.verbatim
boolean

## hyphenate.verbatim

Should verbatim environments be hyphenated on space characters?

    <xsl:param name="hyphenate.verbatim" select="0"></xsl:param>

### Description

If the lines of program listing are too long to fit into one line it is quite common to split them at space and indicite by hook arrow that code continues on the next line. You can turn on this behaviour for `programlisting`, `screen` and `synopsis` elements by using this parameter.

Note that you must also enable line wrapping for verbatim environments and select appropriate hyphenation character (e.g. hook arrow). This can be done using `monospace.verbatim.properties` attribute set:

    <xsl:attribute-set name="monospace.verbatim.properties"
                       use-attribute-sets="verbatim.properties monospace.properties">
      <xsl:attribute name="wrap-option">wrap</xsl:attribute>
      <xsl:attribute name="hyphenation-character">&#x25BA;</xsl:attribute>
    </xsl:attribute-set>

For a list of arrows available in Unicode see `http://www.unicode.org/charts/PDF/U2190.pdf` and `http://www.unicode.org/charts/PDF/U2900.pdf` and make sure that selected character is available in the font you are using for verbatim environments.

hyphenate.verbatim.characters
string

## hyphenate.verbatim.characters

List of characters after which a line break can occur in listings

    <xsl:param name="hyphenate.verbatim.characters"></xsl:param>

### Description

If you enable `hyphenate.verbatim` line breaks are allowed only on space characters. If this is not enough for your document, you can specify list of additional characters after which line break is allowed in this parameter.

use.svg
boolean

## use.svg

Allow SVG in the result tree?

    <xsl:param name="use.svg" select="1"></xsl:param>

### Description

If non-zero, SVG will be considered an acceptable image format. SVG is passed through to the result tree, so correct rendering of the resulting diagram depends on the formatter (FO processor or web browser) that is used to process the output from the stylesheet.

use.role.as.xrefstyle
boolean

## use.role.as.xrefstyle

Use `role` attribute for `xrefstyle` on `xref`?

    <xsl:param name="use.role.as.xrefstyle" select="1"></xsl:param>

### Description

In DocBook documents that conform to a schema older than V4.3, this parameter allows `role` to serve the purpose of specifying the cross reference style.

If non-zero, the `role` attribute on `xref` will be used to select the cross reference style. In DocBook V4.3, the `xrefstyle` attribute was added for this purpose. If the `xrefstyle` attribute is present, `role` will be ignored, regardless of the setting of this parameter.

### Example

The following small stylesheet shows how to configure the stylesheets to make use of the cross reference style:

    <?xml version="1.0"?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                    version="1.0">

    <xsl:import href="../xsl/html/docbook.xsl"/>

    <xsl:output method="html"/>

    <xsl:param name="local.l10n.xml" select="document('')"/>
    <l:i18n xmlns:l="http://docbook.sourceforge.net/xmlns/l10n/1.0">
      <l:l10n xmlns:l="http://docbook.sourceforge.net/xmlns/l10n/1.0" language="en">
       <l:context name="xref">
          <l:template name="chapter" style="title" text="Chapter %n, %t"/>
          <l:template name="chapter" text="Chapter %n"/>
        </l:context>
      </l:l10n>
    </l:i18n>

    </xsl:stylesheet>

With this stylesheet, the cross references in the following document:

    <?xml version="1.0" encoding="utf-8"?>
    <!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.2//EN"
                      "http://www.oasis-open.org/docbook/xml/4.2/docbookx.dtd">
    <book id="book"><title>Book</title>

    <preface>
    <title>Preface</title>

    <para>Normal: <xref linkend="ch1"/>.</para>
    <para>Title: <xref xrefstyle="title" linkend="ch1"/>.</para>

    </preface>

    <chapter id="ch1">
    <title>First Chapter</title>

    <para>Irrelevant.</para>

    </chapter>
    </book>

will appear as:

Normal: Chapter 1.

Title: Chapter 1, First Chapter.

menuchoice.separator
string

## menuchoice.separator

Separator between items of a `menuchoice` other than `guimenuitem` and `guisubmenu`

    <xsl:param name="menuchoice.separator">+</xsl:param>

### Description

Separator used to connect items of a `menuchoice` other than `guimenuitem` and `guisubmenu`. The latter elements are linked with `menuchoice.menu.separator`.

menuchoice.menu.separator
string

## menuchoice.menu.separator

Separator between items of a `menuchoice` with `guimenuitem` or `guisubmenu`

    <xsl:param name="menuchoice.menu.separator"> → </xsl:param>

### Description

Separator used to connect items of a `menuchoice` with `guimenuitem` or `guisubmenu`. Other elements are linked with `menuchoice.separator`.

The default value is &#x2192;, which is the &rarr; (right arrow) character entity. The current FOP (0.20.5) requires setting the font-family explicitly.

The default value also includes spaces around the arrow, which will allow a line to break. Replace the spaces with &#xA0; (nonbreaking space) if you don't want those spaces to break.

default.float.class
string

## default.float.class

Specifies the default float class

    <xsl:param name="default.float.class">
      <xsl:choose>
        <xsl:when test="contains($stylesheet.result.type,'html')">left</xsl:when>
        <xsl:otherwise>before</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

Selects the direction in which a float should be placed. for xsl-fo this is before, for html it is left. For Western texts, the before direction is the top of the page.

footnote.number.format
list
11,2,3...
AA,B,C...
aa,b,c...
ii,ii,iii...
II,II,III...

## footnote.number.format

Identifies the format used for footnote numbers

    <xsl:param name="footnote.number.format">1</xsl:param>

### Description

The `footnote.number.format` specifies the format to use for footnote numeration (1, i, I, a, or A).

table.footnote.number.format
list
11,2,3...
AA,B,C...
aa,b,c...
ii,ii,iii...
II,II,III...

## table.footnote.number.format

Identifies the format used for footnote numbers in tables

    <xsl:param name="table.footnote.number.format">a</xsl:param>

### Description

The `table.footnote.number.format` specifies the format to use for footnote numeration (1, i, I, a, or A) in tables.

footnote.number.symbols

## footnote.number.symbols

Special characters to use as footnote markers

    <xsl:param name="footnote.number.symbols"></xsl:param>

### Description

If `footnote.number.symbols` is not the empty string, footnotes will use the characters it contains as footnote symbols. For example, *&#x2020;&#x2021;&#x25CA;&#x2720; will identify footnotes with *, †, ‡, ◊, and ✠. If there are more footnotes than symbols, the stylesheets will fall back to numbered footnotes using `footnote.number.format`.

The use of symbols for footnotes depends on the ability of your processor (or browser) to render the symbols you select. Not all systems are capable of displaying the full range of Unicode characters. If the quoted characters in the preceding paragraph are not displayed properly, that's a good indicator that you may have trouble using those symbols for footnotes.

table.footnote.number.symbols
string

## table.footnote.number.symbols

Special characters to use a footnote markers in tables

    <xsl:param name="table.footnote.number.symbols"></xsl:param>

### Description

If `table.footnote.number.symbols` is not the empty string, table footnotes will use the characters it contains as footnote symbols. For example, *&#x2020;&#x2021;&#x25CA;&#x2720; will identify footnotes with *, †, ‡, ◊, and ✠. If there are more footnotes than symbols, the stylesheets will fall back to numbered footnotes using `table.footnote.number.format`.

The use of symbols for footnotes depends on the ability of your processor (or browser) to render the symbols you select. Not all systems are capable of displaying the full range of Unicode characters. If the quoted characters in the preceding paragraph are not displayed properly, that's a good indicator that you may have trouble using those symbols for footnotes.

footnote.properties
attribute set

## footnote.properties

Properties applied to each footnote body

    <xsl:attribute-set name="footnote.properties">
      <xsl:attribute name="font-family"><xsl:value-of select="$body.fontset"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="font-size"><xsl:value-of select="$footnote.font.size"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="font-weight">normal</xsl:attribute>
      <xsl:attribute name="font-style">normal</xsl:attribute>
      <xsl:attribute name="text-align"><xsl:value-of select="$alignment"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="start-indent">0pt</xsl:attribute>
      <xsl:attribute name="text-indent">0pt</xsl:attribute>
      <xsl:attribute name="hyphenate"><xsl:value-of select="$hyphenate"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="wrap-option">wrap</xsl:attribute>
      <xsl:attribute name="linefeed-treatment">treat-as-space</xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is applied to the footnote-block for each footnote. It can be used to set the font-size, font-family, and other inheritable properties that will be applied to all footnotes.

table.footnote.properties
attribute set

## table.footnote.properties

Properties applied to each table footnote body

    <xsl:attribute-set name="table.footnote.properties">
      <xsl:attribute name="font-family"><xsl:value-of select="$body.fontset"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="font-size"><xsl:value-of select="$footnote.font.size"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="font-weight">normal</xsl:attribute>
      <xsl:attribute name="font-style">normal</xsl:attribute>
      <xsl:attribute name="space-before">2pt</xsl:attribute>
      <xsl:attribute name="text-align"><xsl:value-of select="$alignment"></xsl:value-of></xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is applied to the footnote-block for each table footnote. It can be used to set the font-size, font-family, and other inheritable properties that will be applied to all table footnotes.

footnote.mark.properties
attribute set

## footnote.mark.properties

Properties applied to each footnote mark

    <xsl:attribute-set name="footnote.mark.properties">
      <xsl:attribute name="font-family"><xsl:value-of select="$body.fontset"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="font-size">75%</xsl:attribute>
      <xsl:attribute name="font-weight">normal</xsl:attribute>
      <xsl:attribute name="font-style">normal</xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is applied to the footnote mark used for each footnote. It should contain only inline properties.

The property to make the mark a superscript is contained in the footnote template itself, because the current version of FOP reports an error if baseline-shift is used.

footnote.sep.leader.properties
attribute set

## footnote.sep.leader.properties

Properties associated with footnote separators

    <xsl:attribute-set name="footnote.sep.leader.properties">
      <xsl:attribute name="color">black</xsl:attribute>
      <xsl:attribute name="leader-pattern">rule</xsl:attribute>
      <xsl:attribute name="leader-length">1in</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for the rule line that separates the footnotes from the body text. These are properties applied to the fo:leader used as the separator.

If you want to do more than just set properties on the leader element, then you can customize the template named `footnote.separator` in `fo/pagesetup.xsl`.

xref.with.number.and.title
boolean

## xref.with.number.and.title

Use number and title in cross references

    <xsl:param name="xref.with.number.and.title" select="1"></xsl:param>

### Description

A cross reference may include the number (for example, the number of an example or figure) and the `title` which is a required child of some targets. This parameter inserts both the relevant number as well as the title into the link.

superscript.properties
attribute set

## superscript.properties

Properties associated with superscripts

    <xsl:attribute-set name="superscript.properties">
      <xsl:attribute name="font-size">75%</xsl:attribute>
    </xsl:attribute-set>

### Description

Specifies styling properties for superscripts.

subscript.properties
attribute set

## subscript.properties

Properties associated with subscripts

    <xsl:attribute-set name="subscript.properties">
      <xsl:attribute name="font-size">75%</xsl:attribute>
    </xsl:attribute-set>

### Description

Specifies styling properties for subscripts.

pgwide.properties
attribute set

## pgwide.properties

Properties to make a figure or table page wide.

    <xsl:attribute-set name="pgwide.properties">
      <xsl:attribute name="start-indent">0pt</xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is used to set the properties that make a figure or table "page wide" in fo output. It comes into effect when an attribute `pgwide="1"` is used.

By default, it sets `start-indent` to `0pt`. In a stylesheet that sets the parameter `body.start.indent` to a non-zero value in order to indent body text, this attribute set can be used to outdent pgwide figures to the start margin.

If a document uses a multi-column page layout, then this attribute set could try setting `span` to a value of `all`. However, this may not work with some processors because a span property must be on an fo:block that is a direct child of fo:flow. It may work in some processors anyway.

highlight.source
boolean

## highlight.source

Should the content of `programlisting` be syntactically highlighted?

    <xsl:param name="highlight.source" select="0"></xsl:param>

### Description

When this parameter is non-zero, the stylesheets will try to do syntax highlighting of the content of `programlisting` elements. You specify the language for each programlisting by using the `language` attribute. The `highlight.default.language` parameter can be used to specify the language for programlistings without a `language` attribute. Syntax highlighting also works for `screen` and `synopsis` elements.

The actual highlighting work is done by the XSLTHL extension module. This is an external Java library that has to be downloaded separately (see below).

In order to use this extension, you must

- add `xslthl-2.x.x.jar` to your Java classpath. The latest version is available from the XSLT syntax highlighting project at SourceForge.

- use a customization layer in which you import one of the following stylesheet modules:

  - `html/highlight.xsl`

  - `xhtml/highlight.xsl`

  - `xhtml-1_1/highlight.xsl`

  - `fo/highlight.xsl`

- let either the `xslthl.config` Java system property or the `highlight.xslthl.config` parameter point to the configuration file for syntax highlighting (using URL syntax). DocBook XSL comes with a ready-to-use configuration file, `highlighting/xslthl-config.xml`.

The extension works with Saxon 6.5.x and Xalan-J. (Saxon 8.5 or later is also supported, but since it is an XSLT 2.0 processor it is not guaranteed to work with DocBook XSL in all circumstances.)

The following is an example of a Saxon 6 command adapted for syntax highlighting, to be used on Windows:

`java -cp c:/Java/saxon.jar;c:/Java/xslthl-2.0.1.jar -Dxslthl.config=file:///c:/docbook-xsl/highlighting/xslthl-config.xml com.icl.saxon.StyleSheet -o test.html test.xml myhtml.xsl`

highlight.xslthl.config
uri

## highlight.xslthl.config

Location of XSLTHL configuration file

    <xsl:param name="highlight.xslthl.config"></xsl:param>

### Description

This location has precedence over the corresponding Java property.

Please note that usually you have to specify location as URL not just as a simple path on the local filesystem. E.g. `file:///home/user/xslthl/my-xslthl-config.xml`.

highlight.default.language
string

## highlight.default.language

Default language of programlisting

    <xsl:param name="highlight.default.language"></xsl:param>

### Description

This language is used when there is no language attribute on programlisting.

email.delimiters.enabled
boolean

## email.delimiters.enabled

Generate delimiters around email addresses?

    <xsl:param name="email.delimiters.enabled" select="1"></xsl:param>

### Description

If non-zero, delimiters

For delimiters, the stylesheets are currently hard-coded to output angle brackets.

are generated around e-mail addresses (the output of the `email` element).

email.mailto.enabled
boolean

## email.mailto.enabled

Generate mailto: links for email addresses?

    <xsl:param name="email.mailto.enabled" select="0"></xsl:param>

### Description

If non-zero the generated output for the `email` element will be a clickable mailto: link that brings up the default mail client on the system.

section.container.element
list
block
wrapper

## section.container.element

Select XSL-FO element name to contain sections

    <xsl:param name="section.container.element">block</xsl:param>

### Description

Selects the element name for outer container of each section. The choices are `block` (default) or `wrapper`. The `fo:` namespace prefix is added by the stylesheet to form the full element name.

This element receives the section `id` attribute and the appropriate section level attribute-set.

Changing this parameter to `wrapper` is only necessary when producing multi-column output that contains page-wide spans. Using `fo:wrapper` avoids the nesting of `fo:block` elements that prevents spans from working (the standard says a span must be on a block that is a direct child of `fo:flow`).

If set to `wrapper`, the section attribute-sets only support properties that are inheritable. That's because there is no block to apply them to. Properties such as font-family are inheritable, but properties such as border are not.

Only some XSL-FO processors need to use this parameter. The Antenna House processor, for example, will handle spans in nested blocks without changing the element name. The RenderX XEP product and FOP follow the XSL-FO standard and need to use `wrapper`.

monospace.verbatim.font.width
length

## monospace.verbatim.font.width

Width of a single monospace font character

    <xsl:param name="monospace.verbatim.font.width">0.60em</xsl:param>

### Description

Specifies with em units the width of a single character of the monospace font. The default value is `0.6em`.

This parameter is only used when a `screen` or `programlisting` element has a `width` attribute, which is expressed as a plain integer to indicate the maximum character count of each line. To convert this character count to an actual maximum width measurement, the width of the font characters must be provided. Different monospace fonts have different character width, so this parameter should be adjusted to fit the monospace font being used.

exsl.node.set.available
boolean

## exsl.node.set.available

Is the test function-available('exsl:node-set') true?

    <xsl:param name="exsl.node.set.available">
      <xsl:choose>
        <xsl:when exsl:foo="" test="function-available('exsl:node-set') or                        contains(system-property('xsl:vendor'),                          'Apache Software Foundation')">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

If non-zero, then the exsl:node-set() function is available to be used in the stylesheet. If zero, then the function is not available. This param automatically detects the presence of the function and does not normally need to be set manually.

This param was created to handle a long-standing bug in the Xalan processor that fails to detect the function even though it is available.

bookmarks.collapse
boolean

## bookmarks.collapse

Specifies the initial state of bookmarks

    <xsl:param name="bookmarks.collapse" select="1"></xsl:param>

### Description

If non-zero, the bookmark tree is collapsed so that only the top-level bookmarks are displayed initially. Otherwise, the whole tree of bookmarks is displayed.

This parameter currently works with FOP 0.93 or later.

## Graphics

graphic.default.extension
string

## graphic.default.extension

Default extension for graphic filenames

    <xsl:param name="graphic.default.extension"></xsl:param>

### Description

If a `graphic` or `mediaobject` includes a reference to a filename that does not include an extension, and the `format` attribute is unspecified, the default extension will be used.

default.image.width
length

## default.image.width

The default width of images

    <xsl:param name="default.image.width"></xsl:param>

### Description

If specified, this value will be used for the `width` attribute on images that do not specify any viewport dimensions.

preferred.mediaobject.role
string

## preferred.mediaobject.role

Select which mediaobject to use based on this value of an object's `role` attribute.

    <xsl:param name="preferred.mediaobject.role"></xsl:param>

### Description

A mediaobject may contain several objects such as imageobjects. If the parameter `use.role.for.mediaobject` is non-zero, then the `role` attribute on `imageobject`s and other objects within a `mediaobject` container will be used to select which object will be used. If one of the objects has a role value that matches the `preferred.mediaobject.role` parameter, then it has first priority for selection. If more than one has such a role value, the first one is used.

See the `use.role.for.mediaobject` parameter for the sequence of selection.

use.role.for.mediaobject
boolean

## use.role.for.mediaobject

Use `role` attribute value for selecting which of several objects within a mediaobject to use.

    <xsl:param name="use.role.for.mediaobject" select="1"></xsl:param>

### Description

If non-zero, the `role` attribute on `imageobject`s or other objects within a `mediaobject` container will be used to select which object will be used.

The order of selection when then parameter is non-zero is:

1. If the stylesheet parameter `preferred.mediaobject.role` has a value, then the object whose role equals that value is selected.

2. Else if an object's role attribute has a value of `html` for HTML processing or `fo` for FO output, then the first of such objects is selected.

3. Else the first suitable object is selected.

If the value of `use.role.for.mediaobject` is zero, then role attributes are not considered and the first suitable object with or without a role value is used.

ignore.image.scaling
boolean

## ignore.image.scaling

Tell the stylesheets to ignore the author's image scaling attributes

    <xsl:param name="ignore.image.scaling" select="0"></xsl:param>

### Description

If non-zero, the scaling attributes on graphics and media objects are ignored.

img.src.path
string

## img.src.path

Path to HTML/FO image files

    <xsl:param name="img.src.path"></xsl:param>

### Description

Add a path prefix to the value of the `fileref` attribute of `graphic`, `inlinegraphic`, and `imagedata` elements. The resulting compound path is used in the output as the value of the `src` attribute of `img` (HTML) or `external-graphic` (FO).

The path given by `img.src.path` could be relative to the directory where the HTML/FO files are created, or it could be an absolute URI. The default value is empty. Be sure to include a trailing slash if needed.

This prefix is not applied to any filerefs that start with "/" or contain "//:".

keep.relative.image.uris
boolean

## keep.relative.image.uris

Should image URIs be resolved against xml:base?

    <xsl:param name="keep.relative.image.uris" select="0"></xsl:param>

### Description

If non-zero, relative URIs (in, for example `fileref` attributes) will be used in the generated output. Otherwise, the URIs will be made absolute with respect to the base URI.

Note that the stylesheets calculate (and use) the absolute form for some purposes, this only applies to the resulting output.

## Pagination and General Styles

## Understanding XSL FO Margins

To make sense of the parameters in this section, it's useful to consider .

### Page Model

Figure showing page margins

This figure shows the physical page with the various FO page regions identified.

First, let's consider the regions on the page.

The white region is the physical page. Its dimensions are determined by the `page.height` and `page.width` parameters.

The yellow region is the region-body. The size and placement of the region body is constrained by the dimensions labelled in the figure.

The pink region at the top of the page is the region-before. The darker area inside the region-before is the header text. In XSL, the default display alignment for a region is `before`, but the DocBook stylesheets still explicitly make it `before`. That's why the darker area is at the top.

The pink region at the bottom of the page is the region-after. The darker area is the footer text. In XSL, the default display alignment for a region is `before`, but the DocBook stylesheets explicitly make it `after`. That's why the darker area is at the bottom.

The dimensions in the figure are:

1. The page-master margin-top.

2. The region-before extent.

3. The region-body margin-top.

4. The region-after extent.

5. The page-master margin-bottom.

6. The region-body margin-bottom.

7. The sum of the page-master margin-left and the region-body margin-left. In DocBook, the region-body margin-left is zero by default, so this is simply the page-master margin-left.

8. The sum of the page-master margin-right and the region-body margin-right. In DocBook, the region-body margin-right is zero by default, so this is simply the page-master margin-right.

page.height
length

## page.height

The height of the physical page

    <xsl:param name="page.height">
      <xsl:choose>
        <xsl:when test="$page.orientation = 'portrait'">
          <xsl:value-of select="$page.height.portrait"></xsl:value-of>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$page.width.portrait"></xsl:value-of>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

The page height is generally calculated from the `paper.type` and `page.orientation` parameters.

page.height.portrait
length

## page.height.portrait

Specify the physical size of the long edge of the page

    <xsl:param name="page.height.portrait">
      <xsl:choose>
        <xsl:when test="$paper.type = 'A4landscape'">210mm</xsl:when>
        <xsl:when test="$paper.type = 'USletter'">11in</xsl:when>
        <xsl:when test="$paper.type = 'USlandscape'">8.5in</xsl:when>
        <xsl:when test="$paper.type = '4A0'">2378mm</xsl:when>
        <xsl:when test="$paper.type = '2A0'">1682mm</xsl:when>
        <xsl:when test="$paper.type = 'A0'">1189mm</xsl:when>
        <xsl:when test="$paper.type = 'A1'">841mm</xsl:when>
        <xsl:when test="$paper.type = 'A2'">594mm</xsl:when>
        <xsl:when test="$paper.type = 'A3'">420mm</xsl:when>
        <xsl:when test="$paper.type = 'A4'">297mm</xsl:when>
        <xsl:when test="$paper.type = 'A5'">210mm</xsl:when>
        <xsl:when test="$paper.type = 'A6'">148mm</xsl:when>
        <xsl:when test="$paper.type = 'A7'">105mm</xsl:when>
        <xsl:when test="$paper.type = 'A8'">74mm</xsl:when>
        <xsl:when test="$paper.type = 'A9'">52mm</xsl:when>
        <xsl:when test="$paper.type = 'A10'">37mm</xsl:when>
        <xsl:when test="$paper.type = 'B0'">1414mm</xsl:when>
        <xsl:when test="$paper.type = 'B1'">1000mm</xsl:when>
        <xsl:when test="$paper.type = 'B2'">707mm</xsl:when>
        <xsl:when test="$paper.type = 'B3'">500mm</xsl:when>
        <xsl:when test="$paper.type = 'B4'">353mm</xsl:when>
        <xsl:when test="$paper.type = 'B5'">250mm</xsl:when>
        <xsl:when test="$paper.type = 'B6'">176mm</xsl:when>
        <xsl:when test="$paper.type = 'B7'">125mm</xsl:when>
        <xsl:when test="$paper.type = 'B8'">88mm</xsl:when>
        <xsl:when test="$paper.type = 'B9'">62mm</xsl:when>
        <xsl:when test="$paper.type = 'B10'">44mm</xsl:when>
        <xsl:when test="$paper.type = 'C0'">1297mm</xsl:when>
        <xsl:when test="$paper.type = 'C1'">917mm</xsl:when>
        <xsl:when test="$paper.type = 'C2'">648mm</xsl:when>
        <xsl:when test="$paper.type = 'C3'">458mm</xsl:when>
        <xsl:when test="$paper.type = 'C4'">324mm</xsl:when>
        <xsl:when test="$paper.type = 'C5'">229mm</xsl:when>
        <xsl:when test="$paper.type = 'C6'">162mm</xsl:when>
        <xsl:when test="$paper.type = 'C7'">114mm</xsl:when>
        <xsl:when test="$paper.type = 'C8'">81mm</xsl:when>
        <xsl:when test="$paper.type = 'C9'">57mm</xsl:when>
        <xsl:when test="$paper.type = 'C10'">40mm</xsl:when>
        <xsl:otherwise>11in</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

The portrait page height is the length of the long edge of the physical page.

page.margin.bottom
length

## page.margin.bottom

The bottom margin of the page

    <xsl:param name="page.margin.bottom">0.5in</xsl:param>

### Description

The bottom page margin is the distance from the bottom of the region-after to the physical bottom of the page.

page.margin.inner
length

## page.margin.inner

The inner page margin

    <xsl:param name="page.margin.inner">
      <xsl:choose>
        <xsl:when test="$double.sided != 0">1.25in</xsl:when>
        <xsl:otherwise>1in</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

The inner page margin is the distance from bound edge of the page to the first column of text.

The inner page margin is the distance from bound edge of the page to the outer edge of the first column of text.

In left-to-right text direction, this is the left margin of recto (front side) pages. For single-sided output, it is the left margin of all pages.

In right-to-left text direction, this is the right margin of recto pages. For single-sided output, this is the right margin of all pages.

Current versions (at least as of version 4.13) of the XEP XSL-FO processor do not correctly handle these margin settings for documents with right-to-left text direction. The workaround in that situation is to reverse the values for `page.margin.inner` and `page.margin.outer`, until this bug is fixed by RenderX. It does not affect documents with left-to-right text direction.

page.margin.outer
length

## page.margin.outer

The outer page margin

    <xsl:param name="page.margin.outer">
      <xsl:choose>
        <xsl:when test="$double.sided != 0">0.75in</xsl:when>
        <xsl:otherwise>1in</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

The outer page margin is the distance from non-bound edge of the page to the outer edge of the last column of text.

In left-to-right text direction, this is the right margin of recto (front side) pages. For single-sided output, it is the right margin of all pages.

In right-to-left text direction, this is the left margin of recto pages. For single-sided output, this is the left margin of all pages.

Current versions (at least as of version 4.13) of the XEP XSL-FO processor do not correctly handle these margin settings for documents with right-to-left text direction. The workaround in that situation is to reverse the values for `page.margin.inner` and `page.margin.outer`, until this bug is fixed by RenderX. It does not affect documents with left-to-right text direction.

page.margin.top
length

## page.margin.top

The top margin of the page

    <xsl:param name="page.margin.top">0.5in</xsl:param>

### Description

The top page margin is the distance from the physical top of the page to the top of the region-before.

page.orientation
list
portrait
landscape

## page.orientation

Select the page orientation

    <xsl:param name="page.orientation">portrait</xsl:param>

### Description

Select one from portrait or landscape. In portrait orientation, the short edge is horizontal; in landscape orientation, it is vertical.

page.width
length

## page.width

The width of the physical page

    <xsl:param name="page.width">
      <xsl:choose>
        <xsl:when test="$page.orientation = 'portrait'">
          <xsl:value-of select="$page.width.portrait"></xsl:value-of>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$page.height.portrait"></xsl:value-of>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

The page width is generally calculated from the `paper.type` and `page.orientation` parameters.

page.width.portrait
length

## page.width.portrait

Specify the physical size of the short edge of the page

    <xsl:param name="page.width.portrait">
      <xsl:choose>
        <xsl:when test="$paper.type = 'USletter'">8.5in</xsl:when>
        <xsl:when test="$paper.type = '4A0'">1682mm</xsl:when>
        <xsl:when test="$paper.type = '2A0'">1189mm</xsl:when>
        <xsl:when test="$paper.type = 'A0'">841mm</xsl:when>
        <xsl:when test="$paper.type = 'A1'">594mm</xsl:when>
        <xsl:when test="$paper.type = 'A2'">420mm</xsl:when>
        <xsl:when test="$paper.type = 'A3'">297mm</xsl:when>
        <xsl:when test="$paper.type = 'A4'">210mm</xsl:when>
        <xsl:when test="$paper.type = 'A5'">148mm</xsl:when>
        <xsl:when test="$paper.type = 'A6'">105mm</xsl:when>
        <xsl:when test="$paper.type = 'A7'">74mm</xsl:when>
        <xsl:when test="$paper.type = 'A8'">52mm</xsl:when>
        <xsl:when test="$paper.type = 'A9'">37mm</xsl:when>
        <xsl:when test="$paper.type = 'A10'">26mm</xsl:when>
        <xsl:when test="$paper.type = 'B0'">1000mm</xsl:when>
        <xsl:when test="$paper.type = 'B1'">707mm</xsl:when>
        <xsl:when test="$paper.type = 'B2'">500mm</xsl:when>
        <xsl:when test="$paper.type = 'B3'">353mm</xsl:when>
        <xsl:when test="$paper.type = 'B4'">250mm</xsl:when>
        <xsl:when test="$paper.type = 'B5'">176mm</xsl:when>
        <xsl:when test="$paper.type = 'B6'">125mm</xsl:when>
        <xsl:when test="$paper.type = 'B7'">88mm</xsl:when>
        <xsl:when test="$paper.type = 'B8'">62mm</xsl:when>
        <xsl:when test="$paper.type = 'B9'">44mm</xsl:when>
        <xsl:when test="$paper.type = 'B10'">31mm</xsl:when>
        <xsl:when test="$paper.type = 'C0'">917mm</xsl:when>
        <xsl:when test="$paper.type = 'C1'">648mm</xsl:when>
        <xsl:when test="$paper.type = 'C2'">458mm</xsl:when>
        <xsl:when test="$paper.type = 'C3'">324mm</xsl:when>
        <xsl:when test="$paper.type = 'C4'">229mm</xsl:when>
        <xsl:when test="$paper.type = 'C5'">162mm</xsl:when>
        <xsl:when test="$paper.type = 'C6'">114mm</xsl:when>
        <xsl:when test="$paper.type = 'C7'">81mm</xsl:when>
        <xsl:when test="$paper.type = 'C8'">57mm</xsl:when>
        <xsl:when test="$paper.type = 'C9'">40mm</xsl:when>
        <xsl:when test="$paper.type = 'C10'">28mm</xsl:when>
        <xsl:otherwise>8.5in</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

The portrait page width is the length of the short edge of the physical page.

paper.type
list
open
open
USletter8.5x11in
USlandscape11x8.5in
USlegal8.5inx14in
USlegallandscape14inx8.5in
4A02378x1682mm
2A01682x1189mm
A01189x841mm
A1841x594mm
A2594x420mm
A3420x297mm
A4297x210mm
A5210x148mm
A6148x105mm
A7105x74mm
A874x52mm
A952x37mm
A1037x26mm
B01414x1000mm
B11000x707mm
B2707x500mm
B3500x353mm
B4353x250mm
B5250x176mm
B6176x125mm
B7125x88mm
B888x62mm
B962x44mm
B1044x31mm
C01297x917mm
C1917x648mm
C2648x458mm
C3458x324mm
C4324x229mm
C5229x162mm
C6162x114mm
C7114x81mm
C881x57mm
C957x40mm
C1040x28mm

## paper.type

Select the paper type

    <xsl:param name="paper.type">USletter</xsl:param>

### Description

The paper type is a convenient way to specify the paper size. The list of known paper sizes includes USletter and most of the A, B, and C sizes. See `page.width.portrait`, for example.

double.sided
boolean

## double.sided

Is the document to be printed double sided?

    <xsl:param name="double.sided" select="0"></xsl:param>

### Description

Double-sided documents are printed with a slightly wider margin on the binding edge of the page.

FIXME: The current set of parameters does not take writing direction into account.

body.margin.bottom
length

## body.margin.bottom

The bottom margin of the body text

    <xsl:param name="body.margin.bottom">0.5in</xsl:param>

### Description

The body bottom margin is the distance from the last line of text in the page body to the bottom of the region-after.

body.margin.top
length

## body.margin.top

To specify the size of the top margin of a page

    <xsl:param name="body.margin.top">0.5in</xsl:param>

### Description

The body top margin is the distance from the top of the region-before to the first line of text in the page body.

body.start.indent
length

## body.start.indent

The start-indent for the body text

    <xsl:param name="body.start.indent">
      <xsl:choose>
        <xsl:when test="$fop.extensions != 0">0pt</xsl:when>
        <xsl:when test="$passivetex.extensions != 0">0pt</xsl:when>
        <xsl:otherwise>4pc</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

This parameter provides the means of indenting the body text relative to section titles. For left-to-right text direction, it indents the left side. For right-to-left text direction, it indents the right side. It is used in place of the `title.margin.left` for all XSL-FO processors except FOP 0.25. It enables support for side floats to appear in the indented margin area.

This start-indent property is added to the fo:flow for certain page sequences. Which page-sequences it is applied to is determined by the template named `set.flow.properties`. By default, that template adds it to the flow for page-sequences using the body master-reference, as well as appendixes and prefaces.

If this parameter is used, section titles should have a start-indent value of 0pt if they are to be outdented relative to the body text.

If you are using FOP, then set this parameter to a zero width value and set the `title.margin.left` parameter to the negative value of the desired indent.

See also `body.end.indent` and `title.margin.left`.

body.end.indent
length

## body.end.indent

The end-indent for the body text

    <xsl:param name="body.end.indent">0pt</xsl:param>

### Description

This end-indent property is added to the fo:flow for certain page sequences. Which page-sequences it is applied to is determined by the template named `set.flow.properties`. By default, that template adds it to the flow for page-sequences using the body master-reference, as well as appendixes and prefaces.

See also `body.start.indent`.

alignment
list
open
left
start
right
end
center
justify

## alignment

Specify the default text alignment

    <xsl:param name="alignment">justify</xsl:param>

### Description

The default text alignment is used for most body text. Allowed values are `left`, `right`, `start`, `end`, `center`, `justify`. The default value is `justify`.

hyphenate
list
closed
true
false

## hyphenate

Specify hyphenation behavior

    <xsl:param name="hyphenate">true</xsl:param>

### Description

If true, words may be hyphenated. Otherwise, they may not.

line-height
string

## line-height

Specify the line-height property

    <xsl:param name="line-height">normal</xsl:param>

### Description

Sets the line-height property.

column.count.back
integer

## column.count.back

Number of columns on back matter pages

    <xsl:param name="column.count.back" select="1"></xsl:param>

### Description

Number of columns on back matter (appendix, glossary, etc.) pages.

column.count.body
integer

## column.count.body

Number of columns on body pages

    <xsl:param name="column.count.body" select="1"></xsl:param>

### Description

Number of columns on body pages.

column.count.front
integer

## column.count.front

Number of columns on front matter pages

    <xsl:param name="column.count.front" select="1"></xsl:param>

### Description

Number of columns on front matter (dedication, preface, etc.) pages.

column.count.index
integer

## column.count.index

Number of columns on index pages

    <xsl:param name="column.count.index">2</xsl:param>

### Description

Number of columns on index pages.

column.count.lot
integer

## column.count.lot

Number of columns on a 'List-of-Titles' page

    <xsl:param name="column.count.lot" select="1"></xsl:param>

### Description

Number of columns on a page sequence containing the Table of Contents, List of Figures, etc.

column.count.titlepage
integer

## column.count.titlepage

Number of columns on a title page

    <xsl:param name="column.count.titlepage" select="1"></xsl:param>

### Description

Number of columns on a title page

column.gap.back
length

## column.gap.back

Gap between columns in back matter

    <xsl:param name="column.gap.back">12pt</xsl:param>

### Description

Specifies the gap between columns in back matter (if `column.count.back` is greater than one).

column.gap.body
length

## column.gap.body

Gap between columns in the body

    <xsl:param name="column.gap.body">12pt</xsl:param>

### Description

Specifies the gap between columns in body matter (if `column.count.body` is greater than one).

column.gap.front
length

## column.gap.front

Gap between columns in the front matter

    <xsl:param name="column.gap.front">12pt</xsl:param>

### Description

Specifies the gap between columns in front matter (if `column.count.front` is greater than one).

column.gap.index
length

## column.gap.index

Gap between columns in the index

    <xsl:param name="column.gap.index">12pt</xsl:param>

### Description

Specifies the gap between columns in indexes (if `column.count.index` is greater than one).

column.gap.lot
length

## column.gap.lot

Gap between columns on a 'List-of-Titles' page

    <xsl:param name="column.gap.lot">12pt</xsl:param>

### Description

Specifies the gap between columns on 'List-of-Titles' pages (if `column.count.lot` is greater than one).

column.gap.titlepage
length

## column.gap.titlepage

Gap between columns on title pages

    <xsl:param name="column.gap.titlepage">12pt</xsl:param>

### Description

Specifies the gap between columns on title pages (if `column.count.titlepage` is greater than one).

region.after.extent
length

## region.after.extent

Specifies the height of the footer.

    <xsl:param name="region.after.extent">0.4in</xsl:param>

### Description

The region after extent is the height of the area where footers are printed.

region.before.extent
length

## region.before.extent

Specifies the height of the header

    <xsl:param name="region.before.extent">0.4in</xsl:param>

### Description

The region before extent is the height of the area where headers are printed.

default.units
list
cm
mm
in
pt
pc
px
em

## default.units

Default units for an unqualified dimension

    <xsl:param name="default.units">pt</xsl:param>

### Description

If an unqualified dimension is encountered (for example, in a graphic width), the `default.units` will be used for the units. Unqualified dimensions are not allowed in XSL Formatting Objects.

normal.para.spacing
attribute set

## normal.para.spacing

What space do you want between normal paragraphs

    <xsl:attribute-set name="normal.para.spacing">
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
    </xsl:attribute-set>

### Description

Specify the spacing required between normal paragraphs

body.font.master
number

## body.font.master

Specifies the default point size for body text

    <xsl:param name="body.font.master">10</xsl:param>

### Description

The body font size is specified in two parameters (`body.font.master` and `body.font.size`) so that math can be performed on the font size by XSLT.

body.font.size
length

## body.font.size

Specifies the default font size for body text

    <xsl:param name="body.font.size">
     <xsl:value-of select="$body.font.master"></xsl:value-of><xsl:text>pt</xsl:text>
    </xsl:param>

### Description

The body font size is specified in two parameters (`body.font.master` and `body.font.size`) so that math can be performed on the font size by XSLT.

footnote.font.size
length

## footnote.font.size

The font size for footnotes

    <xsl:param name="footnote.font.size">
     <xsl:value-of select="$body.font.master * 0.8"></xsl:value-of><xsl:text>pt</xsl:text>
    </xsl:param>

### Description

The footnote font size is used for...footnotes!

title.margin.left
length

## title.margin.left

Adjust the left margin for titles

    <xsl:param name="title.margin.left">
      <xsl:choose>
        <xsl:when test="$fop.extensions != 0">-4pc</xsl:when>
        <xsl:when test="$passivetex.extensions != 0">0pt</xsl:when>
        <xsl:otherwise>0pt</xsl:otherwise>
      </xsl:choose>
    </xsl:param>

### Description

This parameter provides the means of adjusting the left margin for titles when the XSL-FO processor being used is an old version of FOP (0.25 and earlier). It is only useful when the `fop.extensions` is nonzero.

The left margin of the body region is calculated to include this space, and titles are outdented to the left outside the body region by this amount, effectively leaving titles at the intended left margin and the body text indented. Currently this method is only used for old FOP because it cannot properly use the `body.start.indent` parameter.

The default value when the `fop.extensions` parameter is nonzero is -4pc, which means the body text is indented 4 picas relative to the titles. The default value when the `fop.extensions` parameter equals zero is 0pt, and the body indent should instead be specified using the `body.start.indent` parameter.

If you set the value to zero, be sure to still include a unit indicator such as `0pt`, or the FO processor will report errors.

draft.mode
list
no
yes
maybe

## draft.mode

Select draft mode

    <xsl:param name="draft.mode">no</xsl:param>

### Description

Selects draft mode. If `draft.mode` is `yes`, the entire document will be treated as a draft. If it is `no`, the entire document will be treated as a final copy. If it is `maybe`, individual sections will be treated as draft or final independently, depending on how their `status` attribute is set.

draft.watermark.image
uri

## draft.watermark.image

The URI of the image to be used for draft watermarks

    <xsl:param name="draft.watermark.image">images/draft.png</xsl:param>

### Description

The image to be used for draft watermarks.

headers.on.blank.pages
boolean

## headers.on.blank.pages

Put headers on blank pages?

    <xsl:param name="headers.on.blank.pages" select="1"></xsl:param>

### Description

If non-zero, headers will be placed on blank pages.

footers.on.blank.pages
boolean

## footers.on.blank.pages

Put footers on blank pages?

    <xsl:param name="footers.on.blank.pages" select="1"></xsl:param>

### Description

If non-zero, footers will be placed on blank pages.

header.rule
boolean

## header.rule

Rule under headers?

    <xsl:param name="header.rule" select="1"></xsl:param>

### Description

If non-zero, a rule will be drawn below the page headers.

footer.rule
boolean

## footer.rule

Rule over footers?

    <xsl:param name="footer.rule" select="1"></xsl:param>

### Description

If non-zero, a rule will be drawn above the page footers.

header.column.widths
string

## header.column.widths

Specify relative widths of header areas

    <xsl:param name="header.column.widths">1 1 1</xsl:param>

### Description

Page headers in print output use a three column table to position text at the left, center, and right side of the header on the page. This parameter lets you specify the relative sizes of the three columns. The default value is "1 1 1".

The parameter value must be three numbers, separated by white space. The first number represents the relative width of the inside header for double-sided output. The second number is the relative width of the center header. The third number is the relative width of the outside header for double-sided output.

For single-sided output, the first number is the relative width of left header for left-to-right text direction, or the right header for right-to-left text direction. The third number is the relative width of right header for left-to-right text direction, or the left header for right-to-left text direction.

The numbers are used to specify the column widths for the table that makes up the header area. In the FO output, this looks like:

    <fo:table-column column-number="1"
        column-width="proportional-column-width(1)"/>

The `proportional-column-width()` function computes a column width by dividing its argument by the total of the arguments for all the columns, and then multiplying the result by the width of the whole table (assuming all the column specs use the function). Its argument can be any positive integer or floating point number. Zero is an acceptable value, although some FO processors may warn about it, in which case using a very small number might be more satisfactory.

For example, the value "1 2 1" means the center header should have twice the width of the other areas. A value of "0 0 1" means the entire header area is reserved for the right (or outside) header text. Note that to keep the center area centered on the page, the left and right values must be the same. A specification like "1 2 3" means the center area is no longer centered on the page since the right area is three times the width of the left area.

footer.column.widths
string

## footer.column.widths

Specify relative widths of footer areas

    <xsl:param name="footer.column.widths">1 1 1</xsl:param>

### Description

Page footers in print output use a three column table to position text at the left, center, and right side of the footer on the page. This parameter lets you specify the relative sizes of the three columns. The default value is "1 1 1".

The parameter value must be three numbers, separated by white space. The first number represents the relative width of the inside footer for double-sided output. The second number is the relative width of the center footer. The third number is the relative width of the outside footer for double-sided output.

For single-sided output, the first number is the relative width of left footer for left-to-right text direction, or the right footer for right-to-left text direction. The third number is the relative width of right footer for left-to-right text direction, or the left footer for right-to-left text direction.

The numbers are used to specify the column widths for the table that makes up the footer area. In the FO output, this looks like:

    <fo:table-column column-number="1"
        column-width="proportional-column-width(1)"/>

The `proportional-column-width()` function computes a column width by dividing its argument by the total of the arguments for all the columns, and then multiplying the result by the width of the whole table (assuming all the column specs use the function). Its argument can be any positive integer or floating point number. Zero is an acceptable value, although some FO processors may warn about it, in which case using a very small number might be more satisfactory.

For example, the value "1 2 1" means the center footer should have twice the width of the other areas. A value of "0 0 1" means the entire footer area is reserved for the right (or outside) footer text. Note that to keep the center area centered on the page, the left and right values must be the same. A specification like "1 2 3" means the center area is no longer centered on the page since the right area is three times the width of the left area.

header.table.properties
attribute set

## header.table.properties

Apply properties to the header layout table

    <xsl:attribute-set name="header.table.properties">
      <xsl:attribute name="table-layout">fixed</xsl:attribute>
      <xsl:attribute name="width">100%</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties applied to the table that lays out the page header.

header.table.height
length

## header.table.height

Specify the minimum height of the table containing the running page headers

    <xsl:param name="header.table.height">14pt</xsl:param>

### Description

Page headers in print output use a three column table to position text at the left, center, and right side of the header on the page. This parameter lets you specify the minimum height of the single row in the table. Since this specifies only the minimum height, the table should automatically grow to fit taller content. The default value is "14pt".

footer.table.properties
attribute set

## footer.table.properties

Apply properties to the footer layout table

    <xsl:attribute-set name="footer.table.properties">
      <xsl:attribute name="table-layout">fixed</xsl:attribute>
      <xsl:attribute name="width">100%</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties applied to the table that lays out the page footer.

footer.table.height
length

## footer.table.height

Specify the minimum height of the table containing the running page footers

    <xsl:param name="footer.table.height">14pt</xsl:param>

### Description

Page footers in print output use a three column table to position text at the left, center, and right side of the footer on the page. This parameter lets you specify the minimum height of the single row in the table. Since this specifies only the minimum height, the table should automatically grow to fit taller content. The default value is "14pt".

header.content.properties
attribute set

## header.content.properties

Properties of page header content

    <xsl:attribute-set name="header.content.properties">
      <xsl:attribute name="font-family">
        <xsl:value-of select="$body.fontset"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="margin-left">
        <xsl:value-of select="$title.margin.left"></xsl:value-of>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

Properties of page header content.

footer.content.properties
attribute set

## footer.content.properties

Properties of page footer content

    <xsl:attribute-set name="footer.content.properties">
      <xsl:attribute name="font-family">
        <xsl:value-of select="$body.fontset"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="margin-left">
        <xsl:value-of select="$title.margin.left"></xsl:value-of>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

Properties of page footer content.

marker.section.level
integer

## marker.section.level

Control depth of sections shown in running headers or footers

    <xsl:param name="marker.section.level">2</xsl:param>

### Description

The `marker.section.level` parameter controls the depth of section levels that may be displayed in running headers and footers. For example, if the value is 2 (the default), then titles from `sect1` and `sect2` or equivalent `section` elements are candidates for use in running headers and footers.

Each candidate title is marked in the FO output with a `<fo:marker marker-class-name="section.head.marker">` element.

In order for such titles to appear in headers or footers, the `header.content` or `footer.content` template must be customized to retrieve the marker using an output element such as:

    <fo:retrieve-marker retrieve-class-name="section.head.marker"
                           retrieve-position="first-including-carryover"
                           retrieve-boundary="page-sequence"/>

## Font Families

body.font.family
list
open
serif
sans-serif
monospace

## body.font.family

The default font family for body text

    <xsl:param name="body.font.family">serif</xsl:param>

### Description

The body font family is the default font used for text in the page body.

dingbat.font.family
list
open
serif
sans-serif
monospace

## dingbat.font.family

The font family for copyright, quotes, and other symbols

    <xsl:param name="dingbat.font.family">serif</xsl:param>

### Description

The dingbat font family is used for dingbats. If it is defined as the empty string, no font change is effected around dingbats.

monospace.font.family
string

## monospace.font.family

The default font family for monospace environments

    <xsl:param name="monospace.font.family">monospace</xsl:param>

### Description

The monospace font family is used for verbatim environments (program listings, screens, etc.).

sans.font.family
string

## sans.font.family

The default sans-serif font family

    <xsl:param name="sans.font.family">sans-serif</xsl:param>

### Description

The default sans-serif font family. At the present, this isn't actually used by the stylesheets.

title.font.family
list
open
serif
sans-serif
monospace

## title.font.family

The default font family for titles

    <xsl:param name="title.font.family">sans-serif</xsl:param>

### Description

The title font family is used for titles (chapter, section, figure, etc.)

symbol.font.family
list
open
serif
sans-serif
monospace

## symbol.font.family

The font families to be searched for symbols outside of the body font

    <xsl:param name="symbol.font.family">Symbol,ZapfDingbats</xsl:param>

### Description

A typical body or title font does not contain all the character glyphs that DocBook supports. This parameter specifies additional fonts that should be searched for special characters not in the normal font. These symbol font names are automatically appended to the body or title font family name when fonts are specified in a `font-family` property in the FO output.

The symbol font names should be entered as a comma-separated list. The default value is `Symbol,ZapfDingbats`.

## Property Sets

formal.object.properties
attribute set

## formal.object.properties

Properties associated with a formal object such as a figure, or other component that has a title

    <xsl:attribute-set name="formal.object.properties">
      <xsl:attribute name="space-before.minimum">0.5em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">2em</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.5em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">2em</xsl:attribute>
      <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for formal objects in docbook. Specify the spacing before and after the object.

formal.title.properties
attribute set

## formal.title.properties

Style the title element of formal object such as a figure.

    <xsl:attribute-set name="formal.title.properties" use-attribute-sets="normal.para.spacing">
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 1.2"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.4em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">0.6em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">0.8em</xsl:attribute>
    </xsl:attribute-set>

### Description

Specify how the title should be styled. Specify the font size and weight of the title of the formal object.

informal.object.properties
attribute set

## informal.object.properties

Properties associated with an informal (untitled) object, such as an informalfigure

    <xsl:attribute-set name="informal.object.properties">
      <xsl:attribute name="space-before.minimum">0.5em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">2em</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.5em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">2em</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for informal objects in docbook. Specify the spacing before and after the object.

monospace.properties
attribute set

## monospace.properties

Properties of monospaced content

    <xsl:attribute-set name="monospace.properties">
      <xsl:attribute name="font-family">
        <xsl:value-of select="$monospace.font.family"></xsl:value-of>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

Specifies the font name for monospaced output. This property set used to set the font-size as well, but that doesn't work very well when different fonts are used (as they are in titles and paragraphs, for example).

If you want to set the font-size in a customization layer, it's probably going to be more appropriate to set font-size-adjust, if your formatter supports it.

verbatim.properties
attribute set

## verbatim.properties

Properties associated with verbatim text

    <xsl:attribute-set name="verbatim.properties">
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="space-after.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-after.optimum">1em</xsl:attribute>
      <xsl:attribute name="space-after.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="wrap-option">no-wrap</xsl:attribute>
      <xsl:attribute name="white-space-collapse">false</xsl:attribute>
      <xsl:attribute name="white-space-treatment">preserve</xsl:attribute>
      <xsl:attribute name="linefeed-treatment">preserve</xsl:attribute>
      <xsl:attribute name="text-align">start</xsl:attribute>
    </xsl:attribute-set>

### Description

This attribute set is used on all verbatim environments.

monospace.verbatim.properties
attribute set

## monospace.verbatim.properties

What font and size do you want for monospaced content?

    <xsl:attribute-set name="monospace.verbatim.properties" use-attribute-sets="verbatim.properties monospace.properties">
      <xsl:attribute name="text-align">start</xsl:attribute>
      <xsl:attribute name="wrap-option">no-wrap</xsl:attribute>
    </xsl:attribute-set>

### Description

Specify the font name and size you want for monospaced output

sidebar.properties
attribute set

## sidebar.properties

Attribute set for sidebar properties

    <xsl:attribute-set name="sidebar.properties" use-attribute-sets="formal.object.properties">
      <xsl:attribute name="border-style">solid</xsl:attribute>
      <xsl:attribute name="border-width">1pt</xsl:attribute>
      <xsl:attribute name="border-color">black</xsl:attribute>
      <xsl:attribute name="background-color">#DDDDDD</xsl:attribute>
      <xsl:attribute name="padding-start">12pt</xsl:attribute>
      <xsl:attribute name="padding-end">12pt</xsl:attribute>
      <xsl:attribute name="padding-top">6pt</xsl:attribute>
      <xsl:attribute name="padding-bottom">6pt</xsl:attribute>
      <xsl:attribute name="margin-{$direction.align.start}">0pt</xsl:attribute>
      <xsl:attribute name="margin-{$direction.align.end}">0pt</xsl:attribute>
    <!--
      <xsl:attribute name="margin-top">6pt</xsl:attribute>
      <xsl:attribute name="margin-bottom">6pt</xsl:attribute>
    -->
    </xsl:attribute-set>

### Description

The styling for sidebars.

sidebar.title.properties
attribute set

## sidebar.title.properties

Attribute set for sidebar titles

    <xsl:attribute-set name="sidebar.title.properties">
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="text-align">start</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for sidebars titles.

sidebar.float.type
list
none
before
left
start
right
end
inside
outside

## sidebar.float.type

Select type of float for sidebar elements

    <xsl:param name="sidebar.float.type">none</xsl:param>

### Description

Selects the type of float for sidebar elements.

- If `sidebar.float.type` is `none`, then no float is used.

- If `sidebar.float.type` is `before`, then the float appears at the top of the page. On some processors, that may be the next page rather than the current page.

- If `sidebar.float.type` is `left`, then a left side float is used.

- If `sidebar.float.type` is `start`, then when the text direction is left-to-right a left side float is used. When the text direction is right-to-left, a right side float is used.

- If `sidebar.float.type` is `right`, then a right side float is used.

- If `sidebar.float.type` is `end`, then when the text direction is left-to-right a right side float is used. When the text direction is right-to-left, a left side float is used.

- If your XSL-FO processor supports floats positioned on the `inside` or `outside` of double-sided pages, then you have those two options for side floats as well.

sidebar.float.width
length

## sidebar.float.width

Set the default width for sidebars

    <xsl:param name="sidebar.float.width">1in</xsl:param>

### Description

Sets the default width for sidebars when used as a side float. The width determines the degree to which the sidebar block intrudes into the text area.

If `sidebar.float.type` is `before` or `none`, then this parameter is ignored.

margin.note.properties
attribute set

## margin.note.properties

Attribute set for margin.note properties

    <xsl:attribute-set name="margin.note.properties">
      <xsl:attribute name="font-size">90%</xsl:attribute>
      <xsl:attribute name="text-align">start</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for margin notes. By default, margin notes are not implemented for any element. A stylesheet customization is needed to make use of this attribute-set.

You can use a template named floater to create the customization. That template can create side floats by specifying the content and characteristics as template parameters.

For example:

    <xsl:template match="para[@role='marginnote']">
      <xsl:call-template name="floater">
        <xsl:with-param name="position">
          <xsl:value-of select="$margin.note.float.type"/>
        </xsl:with-param>
        <xsl:with-param name="width">
          <xsl:value-of select="$margin.note.width"/>
        </xsl:with-param>
        <xsl:with-param name="content">
          <xsl:apply-imports/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:template>

margin.note.title.properties
attribute set

## margin.note.title.properties

Attribute set for margin note titles

    <xsl:attribute-set name="margin.note.title.properties">
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="text-align">start</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for margin note titles.

margin.note.float.type
list
none
before
left
start
right
end
inside
outside

## margin.note.float.type

Select type of float for margin note customizations

    <xsl:param name="margin.note.float.type">none</xsl:param>

### Description

Selects the type of float for margin notes. DocBook does not define a margin note element, so this feature must be implemented as a customization of the stylesheet. See `margin.note.properties` for an example.

- If `margin.note.float.type` is `none`, then no float is used.

- If `margin.note.float.type` is `before`, then the float appears at the top of the page. On some processors, that may be the next page rather than the current page.

- If `margin.note.float.type` is `left` or `start`, then a left side float is used.

- If `margin.note.float.type` is `right` or `end`, then a right side float is used.

- If your XSL-FO processor supports floats positioned on the `inside` or `outside` of double-sided pages, then you have those two options for side floats as well.

margin.note.width
length

## margin.note.width

Set the default width for margin notes

    <xsl:param name="margin.note.width">1in</xsl:param>

### Description

Sets the default width for margin notes when used as a side float. The width determines the degree to which the margin note block intrudes into the text area.

If `margin.note.float.type` is `before` or `none`, then this parameter is ignored.

component.title.properties
attribute set

## component.title.properties

Properties for component titles

    <xsl:attribute-set name="component.title.properties">
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="space-before.optimum"><xsl:value-of select="concat($body.font.master, 'pt')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="space-before.minimum"><xsl:value-of select="concat($body.font.master, 'pt * 0.8')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="space-before.maximum"><xsl:value-of select="concat($body.font.master, 'pt * 1.2')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="text-align">
        <xsl:choose>
          <xsl:when test="((parent::article | parent::articleinfo | parent::info/parent::article) and not(ancestor::book) and not(self::bibliography))         or (parent::slides | parent::slidesinfo)">center</xsl:when>
          <xsl:otherwise>start</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="start-indent"><xsl:value-of select="$title.margin.left"></xsl:value-of></xsl:attribute>
    </xsl:attribute-set>

### Description

The properties common to all component titles.

component.titlepage.properties
attribute set

## component.titlepage.properties

Properties for component titlepages

    <xsl:attribute-set name="component.titlepage.properties">
    </xsl:attribute-set>

### Description

The properties that are applied to the outer block containing all the component title page information. Its main use is to set a `span="all"` property on the block that is a direct child of the flow.

This attribute-set also applies to index titlepages. It is empty by default.

section.title.properties
attribute set

## section.title.properties

Properties for section titles

    <xsl:attribute-set name="section.title.properties">
      <xsl:attribute name="font-family">
        <xsl:value-of select="$title.font.family"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <!-- font size is calculated dynamically by section.heading template -->
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1.0em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
      <xsl:attribute name="text-align">start</xsl:attribute>
      <xsl:attribute name="start-indent"><xsl:value-of select="$title.margin.left"></xsl:value-of></xsl:attribute>
    </xsl:attribute-set>

### Description

The properties common to all section titles.

section.title.level1.properties
attribute set

## section.title.level1.properties

Properties for level-1 section titles

    <xsl:attribute-set name="section.title.level1.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 2.0736"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-1 section titles.

section.title.level2.properties
attribute set

## section.title.level2.properties

Properties for level-2 section titles

    <xsl:attribute-set name="section.title.level2.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 1.728"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-2 section titles.

section.title.level3.properties
attribute set

## section.title.level3.properties

Properties for level-3 section titles

    <xsl:attribute-set name="section.title.level3.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 1.44"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-3 section titles.

section.title.level4.properties
attribute set

## section.title.level4.properties

Properties for level-4 section titles

    <xsl:attribute-set name="section.title.level4.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 1.2"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-4 section titles.

section.title.level5.properties
attribute set

## section.title.level5.properties

Properties for level-5 section titles

    <xsl:attribute-set name="section.title.level5.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-5 section titles.

section.title.level6.properties
attribute set

## section.title.level6.properties

Properties for level-6 section titles

    <xsl:attribute-set name="section.title.level6.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-6 section titles. This property set is actually used for all titles below level 5.

section.properties
attribute set

## section.properties

Properties for all section levels

    <xsl:attribute-set name="section.properties">
    </xsl:attribute-set>

### Description

The properties that apply to the containing block of all section levels, and therefore apply to the whole section. This attribute set is inherited by the more specific attribute sets such as `section.level1.properties`. The default is empty.

section.level1.properties
attribute set

## section.level1.properties

Properties for level-1 sections

    <xsl:attribute-set name="section.level1.properties" use-attribute-sets="section.properties">
    </xsl:attribute-set>

### Description

The properties that apply to the containing block of a level-1 section, and therefore apply to the whole section. This includes `sect1` elements and `section` elements at level 1.

For example, you could start each level-1 section on a new page by using:

    <xsl:attribute-set name="section.level1.properties">
      <xsl:attribute name="break-before">page</xsl:attribute>
    </xsl:attribute-set>

This attribute set inherits attributes from the general `section.properties` attribute set.

section.level2.properties
attribute set

## section.level2.properties

Properties for level-2 sections

    <xsl:attribute-set name="section.level2.properties" use-attribute-sets="section.properties">
    </xsl:attribute-set>

### Description

The properties that apply to the containing block of a level-2 section, and therefore apply to the whole section. This includes `sect2` elements and `section` elements at level 2.

For example, you could start each level-2 section on a new page by using:

    <xsl:attribute-set name="section.level2.properties">
      <xsl:attribute name="break-before">page</xsl:attribute>
    </xsl:attribute-set>

This attribute set inherits attributes from the general `section.properties` attribute set.

section.level3.properties
attribute set

## section.level3.properties

Properties for level-3 sections

    <xsl:attribute-set name="section.level3.properties" use-attribute-sets="section.properties">
    </xsl:attribute-set>

### Description

The properties that apply to the containing block of a level-3 section, and therefore apply to the whole section. This includes `sect3` elements and `section` elements at level 3.

For example, you could start each level-3 section on a new page by using:

    <xsl:attribute-set name="section.level3.properties">
      <xsl:attribute name="break-before">page</xsl:attribute>
    </xsl:attribute-set>

This attribute set inherits attributes from the general `section.properties` attribute set.

section.level4.properties
attribute set

## section.level4.properties

Properties for level-4 sections

    <xsl:attribute-set name="section.level4.properties" use-attribute-sets="section.properties">
    </xsl:attribute-set>

### Description

The properties that apply to the containing block of a level-4 section, and therefore apply to the whole section. This includes `sect4` elements and `section` elements at level 4.

For example, you could start each level-4 section on a new page by using:

    <xsl:attribute-set name="section.level4.properties">
      <xsl:attribute name="break-before">page</xsl:attribute>
    </xsl:attribute-set>

This attribute set inherits attributes from the general `section.properties` attribute set.

section.level5.properties
attribute set

## section.level5.properties

Properties for level-5 sections

    <xsl:attribute-set name="section.level5.properties" use-attribute-sets="section.properties">
    </xsl:attribute-set>

### Description

The properties that apply to the containing block of a level-5 section, and therefore apply to the whole section. This includes `sect5` elements and `section` elements at level 5.

For example, you could start each level-5 section on a new page by using:

    <xsl:attribute-set name="section.level5.properties">
      <xsl:attribute name="break-before">page</xsl:attribute>
    </xsl:attribute-set>

This attribute set inherits attributes from the general `section.properties` attribute set.

section.level6.properties
attribute set

## section.level6.properties

Properties for level-6 sections

    <xsl:attribute-set name="section.level6.properties" use-attribute-sets="section.properties">
    </xsl:attribute-set>

### Description

The properties that apply to the containing block of a level 6 or lower section, and therefore apply to the whole section. This includes `section` elements at level 6 and lower.

For example, you could start each level-6 section on a new page by using:

    <xsl:attribute-set name="section.level6.properties">
      <xsl:attribute name="break-before">page</xsl:attribute>
    </xsl:attribute-set>

This attribute set inherits attributes from the general `section.properties` attribute set.

figure.properties
attribute set

## figure.properties

Properties associated with a figure

    <xsl:attribute-set name="figure.properties" use-attribute-sets="formal.object.properties"></xsl:attribute-set>

### Description

The styling for figures.

example.properties
attribute set

## example.properties

Properties associated with a example

    <xsl:attribute-set name="example.properties" use-attribute-sets="formal.object.properties"></xsl:attribute-set>

### Description

The styling for examples.

equation.properties
attribute set

## equation.properties

Properties associated with a equation

    <xsl:attribute-set name="equation.properties" use-attribute-sets="formal.object.properties"></xsl:attribute-set>

### Description

The styling for equations.

equation.number.properties
attribute set

## equation.number.properties

Properties that apply to the `fo:table-cell` containing the number of an `equation` that does not have a title.

    <xsl:attribute-set name="equation.number.properties">
      <xsl:attribute name="text-align">end</xsl:attribute>
      <xsl:attribute name="display-align">center</xsl:attribute>
    </xsl:attribute-set>

### Description

Properties that apply to the fo:table-cell containing the number of an equation when it has no title. The number in an equation with a title is formatted along with the title, and this attribute-set does not apply.

table.properties
attribute set

## table.properties

Properties associated with the block surrounding a table

    <xsl:attribute-set name="table.properties" use-attribute-sets="formal.object.properties">
      <xsl:attribute name="keep-together.within-column">auto</xsl:attribute>
    </xsl:attribute-set>

### Description

Block styling properties for tables. This parameter should really have been called `table.block.properties` or something like that, but we’re leaving it to avoid backwards-compatibility problems.

See also `table.table.properties`.

informalfigure.properties
attribute set

## informalfigure.properties

Properties associated with an informalfigure

    <xsl:attribute-set name="informalfigure.properties" use-attribute-sets="informal.object.properties"></xsl:attribute-set>

### Description

The styling for informalfigures.

informalexample.properties
attribute set

## informalexample.properties

Properties associated with an informalexample

    <xsl:attribute-set name="informalexample.properties" use-attribute-sets="informal.object.properties"></xsl:attribute-set>

### Description

The styling for informalexamples.

informalequation.properties
attribute set

## informalequation.properties

Properties associated with an informalequation

    <xsl:attribute-set name="informalequation.properties" use-attribute-sets="informal.object.properties"></xsl:attribute-set>

### Description

The styling for informalequations.

informaltable.properties
attribute set

## informaltable.properties

Properties associated with the block surrounding an informaltable

    <xsl:attribute-set name="informaltable.properties" use-attribute-sets="informal.object.properties"></xsl:attribute-set>

### Description

Block styling properties for informaltables. This parameter should really have been called `informaltable.block.properties` or something like that, but we’re leaving it to avoid backwards-compatibility problems.

See also `table.table.properties`.

procedure.properties
attribute set

## procedure.properties

Properties associated with a procedure

    <xsl:attribute-set name="procedure.properties" use-attribute-sets="formal.object.properties">
      <xsl:attribute name="keep-together.within-column">auto</xsl:attribute>
    </xsl:attribute-set>

### Description

The styling for procedures.

root.properties
attribute set

## root.properties

The properties of the fo:root element

    <xsl:attribute-set name="root.properties">
      <xsl:attribute name="font-family">
        <xsl:value-of select="$body.fontset"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.size"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="text-align">
        <xsl:value-of select="$alignment"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="line-height">
        <xsl:value-of select="$line-height"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="font-selection-strategy">character-by-character</xsl:attribute>
      <xsl:attribute name="line-height-shift-adjustment">disregard-shifts</xsl:attribute>
      <xsl:attribute name="writing-mode">
        <xsl:value-of select="$direction.mode"></xsl:value-of>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

This property set is used on the `fo:root` element of an FO file. It defines a set of default, global parameters.

qanda.title.properties
attribute set

## qanda.title.properties

Properties for qanda set titles

    <xsl:attribute-set name="qanda.title.properties">
      <xsl:attribute name="font-family">
        <xsl:value-of select="$title.font.family"></xsl:value-of>
      </xsl:attribute>
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <!-- font size is calculated dynamically by qanda.heading template -->
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
      <xsl:attribute name="space-before.optimum">1.0em</xsl:attribute>
      <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
    </xsl:attribute-set>

### Description

The properties common to all qanda set titles.

qanda.title.level1.properties
attribute set

## qanda.title.level1.properties

Properties for level-1 qanda set titles

    <xsl:attribute-set name="qanda.title.level1.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 2.0736"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-1 qanda set titles.

qanda.title.level2.properties
attribute set

## qanda.title.level2.properties

Properties for level-2 qanda set titles

    <xsl:attribute-set name="qanda.title.level2.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 1.728"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-2 qanda set titles.

qanda.title.level3.properties
attribute set

## qanda.title.level3.properties

Properties for level-3 qanda set titles

    <xsl:attribute-set name="qanda.title.level3.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 1.44"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-3 qanda set titles.

qanda.title.level4.properties
attribute set

## qanda.title.level4.properties

Properties for level-4 qanda set titles

    <xsl:attribute-set name="qanda.title.level4.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master * 1.2"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-4 qanda set titles.

qanda.title.level5.properties
attribute set

## qanda.title.level5.properties

Properties for level-5 qanda set titles

    <xsl:attribute-set name="qanda.title.level5.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-5 qanda set titles.

qanda.title.level6.properties
attribute set

## qanda.title.level6.properties

Properties for level-6 qanda set titles

    <xsl:attribute-set name="qanda.title.level6.properties">
      <xsl:attribute name="font-size">
        <xsl:value-of select="$body.font.master"></xsl:value-of>
        <xsl:text>pt</xsl:text>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties of level-6 qanda set titles. This property set is actually used for all titles below level 5.

article.appendix.title.properties
attribute set

## article.appendix.title.properties

Properties for appendix titles that appear in an article

    <xsl:attribute-set name="article.appendix.title.properties" use-attribute-sets="section.title.properties                          section.title.level1.properties">
      <xsl:attribute name="margin-{$direction.align.start}">
        <xsl:value-of select="$title.margin.left"></xsl:value-of>
      </xsl:attribute>
    </xsl:attribute-set>

### Description

The properties for the title of an appendix that appears inside an article. The default is to use the properties of sect1 titles.

abstract.properties
attribute set

## abstract.properties

Properties associated with the block surrounding an abstract

    <xsl:attribute-set name="abstract.properties">
      <xsl:attribute name="start-indent">0.0in</xsl:attribute>
      <xsl:attribute name="end-indent">0.0in</xsl:attribute>
    </xsl:attribute-set>

### Description

Block styling properties for abstract.

See also `abstract.title.properties`.

abstract.title.properties
attribute set

## abstract.title.properties

Properties for abstract titles

    <xsl:attribute-set name="abstract.title.properties">
      <xsl:attribute name="font-family"><xsl:value-of select="$title.fontset"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="font-weight">bold</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
      <xsl:attribute name="space-before.optimum"><xsl:value-of select="concat($body.font.master, 'pt')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="space-before.minimum"><xsl:value-of select="concat($body.font.master, 'pt * 0.8')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="space-before.maximum"><xsl:value-of select="concat($body.font.master, 'pt * 1.2')"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="hyphenate">false</xsl:attribute>
      <xsl:attribute name="text-align">center</xsl:attribute>
    </xsl:attribute-set>

### Description

The properties for abstract titles.

See also `abstract.properties`.

index.page.number.properties
attribute set

## index.page.number.properties

Properties associated with index page numbers

    <xsl:attribute-set name="index.page.number.properties">
    </xsl:attribute-set>

### Description

Properties associated with page numbers in indexes. Changing color to indicate the page number is a link is one possibility.

revhistory.table.properties
attribute set

## revhistory.table.properties

The properties of table used for formatting revhistory

    <xsl:attribute-set name="revhistory.table.properties">
    </xsl:attribute-set>

### Description

This property set defines appearance of revhistory table.

revhistory.table.cell.properties
attribute set

## revhistory.table.cell.properties

The properties of table cells used for formatting revhistory

    <xsl:attribute-set name="revhistory.table.cell.properties">
    </xsl:attribute-set>

### Description

This property set defines appearance of individual cells in revhistory table.

revhistory.title.properties
attribute set

## revhistory.title.properties

The properties of revhistory title

    <xsl:attribute-set name="revhistory.title.properties">
    </xsl:attribute-set>

### Description

This property set defines appearance of revhistory title.

## Profiling

The following parameters can be used for attribute-based profiling of your document. For more information about profiling, see Profiling (conditional text).

profile.arch
string

## profile.arch

Target profile for `arch` attribute

    <xsl:param name="profile.arch"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.audience
string

## profile.audience

Target profile for `audience` attribute

    <xsl:param name="profile.audience"></xsl:param>

### Description

Value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.condition
string

## profile.condition

Target profile for `condition` attribute

    <xsl:param name="profile.condition"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.conformance
string

## profile.conformance

Target profile for `conformance` attribute

    <xsl:param name="profile.conformance"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.lang
string

## profile.lang

Target profile for `lang` attribute

    <xsl:param name="profile.lang"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.os
string

## profile.os

Target profile for `os` attribute

    <xsl:param name="profile.os"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.revision
string

## profile.revision

Target profile for `revision` attribute

    <xsl:param name="profile.revision"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.revisionflag
string

## profile.revisionflag

Target profile for `revisionflag` attribute

    <xsl:param name="profile.revisionflag"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.role
string

## profile.role

Target profile for `role` attribute

    <xsl:param name="profile.role"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

Note that `role` is often used for other purposes than profiling. For example it is commonly used to get emphasize in bold font:

    <emphasis role="bold">very important</emphasis>

If you are using `role` for these purposes do not forget to add values like `bold` to value of this parameter. If you forgot you will get document with small pieces missing which are very hard to track.

For this reason it is not recommended to use `role` attribute for profiling. You should rather use profiling specific attributes like `userlevel`, `os`, `arch`, `condition`, etc.

profile.security
string

## profile.security

Target profile for `security` attribute

    <xsl:param name="profile.security"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.status
string

## profile.status

Target profile for `status` attribute

    <xsl:param name="profile.status"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.userlevel
string

## profile.userlevel

Target profile for `userlevel` attribute

    <xsl:param name="profile.userlevel"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.vendor
string

## profile.vendor

Target profile for `vendor` attribute

    <xsl:param name="profile.vendor"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.wordsize
string

## profile.wordsize

Target profile for `wordsize` attribute

    <xsl:param name="profile.wordsize"></xsl:param>

### Description

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.attribute
string

## profile.attribute

Name of user-specified profiling attribute

    <xsl:param name="profile.attribute"></xsl:param>

### Description

This parameter is used in conjuction with `profile.value`.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.value
string

## profile.value

Target profile for user-specified attribute

    <xsl:param name="profile.value"></xsl:param>

### Description

When you are using this parameter you must also specify name of profiling attribute with parameter `profile.attribute`.

The value of this parameter specifies profiles which should be included in the output. You can specify multiple profiles by separating them by semicolon. You can change separator character by `profile.separator` parameter.

This parameter has effect only when you are using profiling stylesheets (`profile-docbook.xsl`, `profile-chunk.xsl`, …) instead of normal ones (`docbook.xsl`, `chunk.xsl`, …).

profile.separator
string

## profile.separator

Separator character for compound profile values

    <xsl:param name="profile.separator">;</xsl:param>

### Description

Separator character used for compound profile values. See `profile.arch`

## Localization

l10n.gentext.language
string

## l10n.gentext.language

Sets the gentext language

    <xsl:param name="l10n.gentext.language"></xsl:param>

### Description

If this parameter is set to any value other than the empty string, its value will be used as the value for the language when generating text. Setting `l10n.gentext.language` overrides any settings within the document being formatted.

It's much more likely that you might want to set the `l10n.gentext.default.language` parameter.

l10n.gentext.default.language
string

## l10n.gentext.default.language

Sets the default language for generated text

    <xsl:param name="l10n.gentext.default.language">en</xsl:param>

### Description

The value of the `l10n.gentext.default.language` parameter is used as the language for generated text if no setting is provided in the source document.

l10n.gentext.use.xref.language
boolean

## l10n.gentext.use.xref.language

Use the language of target when generating cross-reference text?

    <xsl:param name="l10n.gentext.use.xref.language" select="0"></xsl:param>

### Description

If non-zero, the language of the target will be used when generating cross reference text. Usually, the current language is used when generating text (that is, the language of the element that contains the cross-reference element). But setting this parameter allows the language of the element pointed to to control the generated text.

Consider the following example:

    <para lang="en">See also <xref linkend="chap3"/>.</para>

Suppose that Chapter 3 happens to be written in German. If `l10n.gentext.use.xref.language` is non-zero, the resulting text will be something like this:

> See also Kapital 3.

Where the more traditional rendering would be:

> See also Chapter 3.

l10n.lang.value.rfc.compliant
boolean

## l10n.lang.value.rfc.compliant

Make value of lang attribute RFC compliant?

    <xsl:param name="l10n.lang.value.rfc.compliant" select="1"></xsl:param>

### Description

If non-zero, ensure that the values for all `lang` attributes in HTML output are RFC compliant Section 8.1.1, Language Codes, in the HTML 4.0 Recommendation states that:

> [RFC1766] defines and explains the language codes that must be used in HTML documents.

> Briefly, language codes consist of a primary code and a possibly empty series of subcodes:

>     language-code = primary-code ( "-" subcode )*

> And in RFC 1766, Tags for the Identification of Languages, the EBNF for "language tag" is given as:

>     Language-Tag = Primary-tag *( "-" Subtag )
>     Primary-tag = 1*8ALPHA
>     Subtag = 1*8ALPHA

.

by taking any underscore characters in any `lang` values found in source documents, and replacing them with hyphen characters in output HTML files. For example, `zh_CN` in a source document becomes `zh-CN` in the HTML output form that source.

This parameter does not cause any case change in `lang` values, because RFC 1766 explicitly states that all "language tags" (as it calls them) "are to be treated as case insensitive".

writing.mode
string

## writing.mode

Direction of text flow based on locale

    <xsl:param name="writing.mode">
      <xsl:call-template name="gentext">
        <xsl:with-param name="key">writing-mode</xsl:with-param>
        <xsl:with-param name="lang">
          <xsl:call-template name="l10n.language">
            <xsl:with-param name="target" select="/*[1]"></xsl:with-param>
          </xsl:call-template>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:param>

### Description

Sets direction of text flow and text alignment based on locale. The value is normally taken from the gentext file for the lang attribute of the document's root element, using the key name 'writing-mode' to look it up in the gentext file. But the param can also be set on the command line to override that gentext value.

Accepted values are:

lr-tb

  Left-to-right text flow in each line, lines stack top to bottom.

rl-tb

  Right-to-left text flow in each line, lines stack top to bottom.

tb-rl

  Top-to-bottom text flow in each vertical line, lines stack right to left. Supported by only a few XSL-FO processors. Not supported in HTML output.

lr

  Shorthand for lr-tb.

rl

  Shorthand for rl-tb.

tb

  Shorthand for tb-rl.

## EBNF

ebnf.assignment
rtf

## ebnf.assignment

The EBNF production assignment operator

    <xsl:param name="ebnf.assignment">
      <fo:inline font-family="{$monospace.font.family}">
        <xsl:text>::=</xsl:text>
      </fo:inline>
    </xsl:param>

### Description

The `ebnf.assignment` parameter determines what text is used to show assignment in `production`s in `productionset`s.

While `::=` is common, so are several other operators.

ebnf.statement.terminator
rtf

## ebnf.statement.terminator

Punctuation that ends an EBNF statement.

    <xsl:param name="ebnf.statement.terminator"></xsl:param>

### Description

The `ebnf.statement.terminator` parameter determines what text is used to terminate each `production` in `productionset`.

Some notations end each statement with a period.

## Prepress

crop.marks
boolean

## crop.marks

Output crop marks?

    <xsl:param name="crop.marks" select="0"></xsl:param>

### Description

If non-zero, crop marks will be added to each page. Currently this works only with XEP if you have `xep.extensions` set.

crop.mark.width
length

## crop.mark.width

Width of crop marks.

    <xsl:param name="crop.mark.width">0.5pt</xsl:param>

### Description

Width of crop marks. Crop marks are controlled by `crop.marks` parameter.

crop.mark.offset
length

## crop.mark.offset

Length of crop marks.

    <xsl:param name="crop.mark.offset">24pt</xsl:param>

### Description

Length of crop marks. Crop marks are controlled by `crop.marks` parameter.

crop.mark.bleed
length

## crop.mark.bleed

Length of invisible part of crop marks.

    <xsl:param name="crop.mark.bleed">6pt</xsl:param>

### Description

Length of invisible part of crop marks. Crop marks are controlled by `crop.marks` parameter.

## The Stylesheet

The `param.xsl` stylesheet is just a wrapper around all these parameters.

    <xsl:stylesheet exclude-result-prefixes="src" version="1.0">

    <!-- This file is generated from param.xweb -->

    <!-- ********************************************************************
         $Id: param.xweb 8543 2009-12-02 06:05:24Z bobstayton $
         ********************************************************************

         This file is part of the XSL DocBook Stylesheet distribution.
         See ../README or http://docbook.sf.net/release/xsl/current/ for
         copyright and other information.

         ******************************************************************** -->

    <src:fragref linkend="abstract.properties.frag"></src:fragref>
    <src:fragref linkend="abstract.title.properties.frag"></src:fragref>
    <src:fragref linkend="admon.graphics.extension.frag"></src:fragref>
    <src:fragref linkend="admon.graphics.frag"></src:fragref>
    <src:fragref linkend="admon.graphics.path.frag"></src:fragref>
    <src:fragref linkend="admon.textlabel.frag"></src:fragref>
    <src:fragref linkend="admonition.properties.frag"></src:fragref>
    <src:fragref linkend="admonition.title.properties.frag"></src:fragref>
    <src:fragref linkend="graphical.admonition.properties.frag"></src:fragref>
    <src:fragref linkend="nongraphical.admonition.properties.frag"></src:fragref>
    <src:fragref linkend="alignment.frag"></src:fragref>
    <src:fragref linkend="appendix.autolabel.frag"></src:fragref>
    <src:fragref linkend="arbortext.extensions.frag"></src:fragref>
    <src:fragref linkend="article.appendix.title.properties.frag"></src:fragref>
    <src:fragref linkend="author.othername.in.middle.frag"></src:fragref>
    <src:fragref linkend="autotoc.label.separator.frag"></src:fragref>
    <src:fragref linkend="axf.extensions.frag"></src:fragref>
    <src:fragref linkend="biblioentry.item.separator.frag"></src:fragref>
    <src:fragref linkend="biblioentry.properties.frag"></src:fragref>
    <src:fragref linkend="bibliography.collection.frag"></src:fragref>
    <src:fragref linkend="bibliography.numbered.frag"></src:fragref>
    <src:fragref linkend="bibliography.style.frag"></src:fragref>
    <src:fragref linkend="blockquote.properties.frag"></src:fragref>
    <src:fragref linkend="body.font.family.frag"></src:fragref>
    <src:fragref linkend="body.font.master.frag"></src:fragref>
    <src:fragref linkend="body.font.size.frag"></src:fragref>
    <src:fragref linkend="body.margin.bottom.frag"></src:fragref>
    <src:fragref linkend="body.margin.top.frag"></src:fragref>
    <src:fragref linkend="body.start.indent.frag"></src:fragref>
    <src:fragref linkend="body.end.indent.frag"></src:fragref>
    <src:fragref linkend="bookmarks.collapse.frag"></src:fragref>
    <src:fragref linkend="bridgehead.in.toc.frag"></src:fragref>
    <src:fragref linkend="callout.defaultcolumn.frag"></src:fragref>
    <src:fragref linkend="callout.graphics.extension.frag"></src:fragref>
    <src:fragref linkend="callout.graphics.frag"></src:fragref>
    <src:fragref linkend="callout.icon.size.frag"></src:fragref>
    <src:fragref linkend="callout.graphics.number.limit.frag"></src:fragref>
    <src:fragref linkend="callout.graphics.path.frag"></src:fragref>
    <src:fragref linkend="callout.unicode.font.frag"></src:fragref>
    <src:fragref linkend="callout.unicode.frag"></src:fragref>
    <src:fragref linkend="callout.unicode.number.limit.frag"></src:fragref>
    <src:fragref linkend="callout.unicode.start.character.frag"></src:fragref>
    <src:fragref linkend="callouts.extension.frag"></src:fragref>
    <src:fragref linkend="chapter.autolabel.frag"></src:fragref>
    <src:fragref linkend="collect.xref.targets.frag"></src:fragref>
    <src:fragref linkend="column.count.back.frag"></src:fragref>
    <src:fragref linkend="column.count.body.frag"></src:fragref>
    <src:fragref linkend="column.count.front.frag"></src:fragref>
    <src:fragref linkend="column.count.index.frag"></src:fragref>
    <src:fragref linkend="column.count.lot.frag"></src:fragref>
    <src:fragref linkend="column.count.titlepage.frag"></src:fragref>
    <src:fragref linkend="column.gap.back.frag"></src:fragref>
    <src:fragref linkend="column.gap.body.frag"></src:fragref>
    <src:fragref linkend="column.gap.front.frag"></src:fragref>
    <src:fragref linkend="column.gap.index.frag"></src:fragref>
    <src:fragref linkend="column.gap.lot.frag"></src:fragref>
    <src:fragref linkend="column.gap.titlepage.frag"></src:fragref>
    <src:fragref linkend="compact.list.item.spacing.frag"></src:fragref>
    <src:fragref linkend="component.label.includes.part.label.frag"></src:fragref>
    <src:fragref linkend="component.title.properties.frag"></src:fragref>
    <src:fragref linkend="component.titlepage.properties.frag"></src:fragref>
    <src:fragref linkend="crop.marks.frag"></src:fragref>
    <src:fragref linkend="crop.mark.width.frag"></src:fragref>
    <src:fragref linkend="crop.mark.offset.frag"></src:fragref>
    <src:fragref linkend="crop.mark.bleed.frag"></src:fragref>
    <src:fragref linkend="current.docid.frag"></src:fragref>
    <src:fragref linkend="default.float.class.frag"></src:fragref>
    <src:fragref linkend="default.image.width.frag"></src:fragref>
    <src:fragref linkend="default.table.width.frag"></src:fragref>
    <src:fragref linkend="default.table.frame.frag"></src:fragref>
    <src:fragref linkend="default.table.rules.frag"></src:fragref>
    <src:fragref linkend="default.units.frag"></src:fragref>
    <src:fragref linkend="dingbat.font.family.frag"></src:fragref>
    <src:fragref linkend="double.sided.frag"></src:fragref>
    <src:fragref linkend="draft.mode.frag"></src:fragref>
    <src:fragref linkend="draft.watermark.image.frag"></src:fragref>
    <src:fragref linkend="ebnf.assignment.frag"></src:fragref>
    <src:fragref linkend="ebnf.statement.terminator.frag"></src:fragref>
    <src:fragref linkend="email.delimiters.enabled.frag"></src:fragref>
    <src:fragref linkend="email.mailto.enabled.frag"></src:fragref>
    <src:fragref linkend="equation.properties.frag"></src:fragref>
    <src:fragref linkend="equation.number.properties.frag"></src:fragref>
    <src:fragref linkend="example.properties.frag"></src:fragref>
    <src:fragref linkend="exsl.node.set.available.frag"></src:fragref>
    <src:fragref linkend="figure.properties.frag"></src:fragref>
    <src:fragref linkend="firstterm.only.link.frag"></src:fragref>
    <src:fragref linkend="footer.content.properties.frag"></src:fragref>
    <src:fragref linkend="footer.rule.frag"></src:fragref>
    <src:fragref linkend="footer.column.widths.frag"></src:fragref>
    <src:fragref linkend="footer.table.height.frag"></src:fragref>
    <src:fragref linkend="footer.table.properties.frag"></src:fragref>
    <src:fragref linkend="footers.on.blank.pages.frag"></src:fragref>
    <src:fragref linkend="footnote.font.size.frag"></src:fragref>
    <src:fragref linkend="footnote.number.format.frag"></src:fragref>
    <src:fragref linkend="footnote.number.symbols.frag"></src:fragref>
    <src:fragref linkend="footnote.mark.properties.frag"></src:fragref>
    <src:fragref linkend="footnote.properties.frag"></src:fragref>
    <src:fragref linkend="footnote.sep.leader.properties.frag"></src:fragref>
    <src:fragref linkend="fop.extensions.frag"></src:fragref>
    <src:fragref linkend="fop1.extensions.frag"></src:fragref>
    <src:fragref linkend="formal.object.properties.frag"></src:fragref>
    <src:fragref linkend="formal.procedures.frag"></src:fragref>
    <src:fragref linkend="formal.title.placement.frag"></src:fragref>
    <src:fragref linkend="formal.title.properties.frag"></src:fragref>
    <src:fragref linkend="funcsynopsis.decoration.frag"></src:fragref>
    <src:fragref linkend="funcsynopsis.style.frag"></src:fragref>
    <src:fragref linkend="function.parens.frag"></src:fragref>
    <src:fragref linkend="generate.index.frag"></src:fragref>
    <src:fragref linkend="generate.section.toc.level.frag"></src:fragref>
    <src:fragref linkend="generate.toc.frag"></src:fragref>
    <src:fragref linkend="glossary.as.blocks.frag"></src:fragref>
    <src:fragref linkend="glossary.collection.frag"></src:fragref>
    <src:fragref linkend="glossary.sort.frag"></src:fragref>
    <src:fragref linkend="glossentry.show.acronym.frag"></src:fragref>
    <src:fragref linkend="glosslist.as.blocks.frag"></src:fragref>
    <src:fragref linkend="glossterm.auto.link.frag"></src:fragref>
    <src:fragref linkend="glossterm.separation.frag"></src:fragref>
    <src:fragref linkend="glossterm.width.frag"></src:fragref>
    <src:fragref linkend="glossentry.list.item.properties.frag"></src:fragref>
    <src:fragref linkend="glossterm.list.properties.frag"></src:fragref>
    <src:fragref linkend="glossterm.block.properties.frag"></src:fragref>
    <src:fragref linkend="glossdef.list.properties.frag"></src:fragref>
    <src:fragref linkend="glossdef.block.properties.frag"></src:fragref>
    <src:fragref linkend="graphic.default.extension.frag"></src:fragref>
    <src:fragref linkend="header.content.properties.frag"></src:fragref>
    <src:fragref linkend="header.rule.frag"></src:fragref>
    <src:fragref linkend="header.column.widths.frag"></src:fragref>
    <src:fragref linkend="header.table.height.frag"></src:fragref>
    <src:fragref linkend="header.table.properties.frag"></src:fragref>
    <src:fragref linkend="headers.on.blank.pages.frag"></src:fragref>
    <src:fragref linkend="highlight.default.language.frag"></src:fragref>
    <src:fragref linkend="highlight.source.frag"></src:fragref>
    <src:fragref linkend="highlight.xslthl.config.frag"></src:fragref>
    <src:fragref linkend="hyphenate.frag"></src:fragref>
    <src:fragref linkend="hyphenate.verbatim.frag"></src:fragref>
    <src:fragref linkend="hyphenate.verbatim.characters.frag"></src:fragref>
    <src:fragref linkend="ignore.image.scaling.frag"></src:fragref>
    <src:fragref linkend="img.src.path.frag"></src:fragref>
    <src:fragref linkend="index.method.frag"></src:fragref>
    <src:fragref linkend="index.on.role.frag"></src:fragref>
    <src:fragref linkend="index.on.type.frag"></src:fragref>
    <src:fragref linkend="index.page.number.properties.frag"></src:fragref>
    <src:fragref linkend="informalequation.properties.frag"></src:fragref>
    <src:fragref linkend="informalexample.properties.frag"></src:fragref>
    <src:fragref linkend="informalfigure.properties.frag"></src:fragref>
    <src:fragref linkend="informal.object.properties.frag"></src:fragref>
    <src:fragref linkend="informaltable.properties.frag"></src:fragref>
    <src:fragref linkend="index.preferred.page.properties.frag"></src:fragref>
    <src:fragref linkend="index.div.title.properties.frag"></src:fragref>
    <src:fragref linkend="index.entry.properties.frag"></src:fragref>
    <src:fragref linkend="index.number.separator.frag"></src:fragref>
    <src:fragref linkend="index.range.separator.frag"></src:fragref>
    <src:fragref linkend="index.term.separator.frag"></src:fragref>
    <src:fragref linkend="insert.link.page.number.frag"></src:fragref>
    <src:fragref linkend="insert.xref.page.number.frag"></src:fragref>
    <src:fragref linkend="itemizedlist.properties.frag"></src:fragref>
    <src:fragref linkend="itemizedlist.label.properties.frag"></src:fragref>
    <src:fragref linkend="itemizedlist.label.width.frag"></src:fragref>
    <src:fragref linkend="keep.relative.image.uris.frag"></src:fragref>
    <src:fragref linkend="l10n.gentext.default.language.frag"></src:fragref>
    <src:fragref linkend="l10n.gentext.language.frag"></src:fragref>
    <src:fragref linkend="l10n.gentext.use.xref.language.frag"></src:fragref>
    <src:fragref linkend="l10n.lang.value.rfc.compliant.frag"></src:fragref>
    <src:fragref linkend="label.from.part.frag"></src:fragref>
    <src:fragref linkend="line-height.frag"></src:fragref>
    <src:fragref linkend="linenumbering.everyNth.frag"></src:fragref>
    <src:fragref linkend="linenumbering.extension.frag"></src:fragref>
    <src:fragref linkend="linenumbering.separator.frag"></src:fragref>
    <src:fragref linkend="linenumbering.width.frag"></src:fragref>
    <src:fragref linkend="list.block.properties.frag"></src:fragref>
    <src:fragref linkend="list.block.spacing.frag"></src:fragref>
    <src:fragref linkend="list.item.spacing.frag"></src:fragref>
    <src:fragref linkend="make.index.markup.frag"></src:fragref>
    <src:fragref linkend="make.single.year.ranges.frag"></src:fragref>
    <src:fragref linkend="make.year.ranges.frag"></src:fragref>
    <src:fragref linkend="margin.note.properties.frag"></src:fragref>
    <src:fragref linkend="margin.note.title.properties.frag"></src:fragref>
    <src:fragref linkend="margin.note.float.type.frag"></src:fragref>
    <src:fragref linkend="margin.note.width.frag"></src:fragref>
    <src:fragref linkend="marker.section.level.frag"></src:fragref>
    <src:fragref linkend="menuchoice.menu.separator.frag"></src:fragref>
    <src:fragref linkend="menuchoice.separator.frag"></src:fragref>
    <src:fragref linkend="monospace.font.family.frag"></src:fragref>
    <src:fragref linkend="monospace.properties.frag"></src:fragref>
    <src:fragref linkend="monospace.verbatim.properties.frag"></src:fragref>
    <src:fragref linkend="monospace.verbatim.font.width.frag"></src:fragref>
    <src:fragref linkend="nominal.table.width.frag"></src:fragref>
    <src:fragref linkend="normal.para.spacing.frag"></src:fragref>
    <src:fragref linkend="olink.doctitle.frag"></src:fragref>
    <src:fragref linkend="olink.base.uri.frag"></src:fragref>
    <src:fragref linkend="olink.debug.frag"></src:fragref>
    <src:fragref linkend="olink.properties.frag"></src:fragref>
    <src:fragref linkend="olink.lang.fallback.sequence.frag"></src:fragref>
    <src:fragref linkend="orderedlist.properties.frag"></src:fragref>
    <src:fragref linkend="orderedlist.label.properties.frag"></src:fragref>
    <src:fragref linkend="orderedlist.label.width.frag"></src:fragref>
    <src:fragref linkend="prefer.internal.olink.frag"></src:fragref>
    <src:fragref linkend="insert.olink.page.number.frag"></src:fragref>
    <src:fragref linkend="insert.olink.pdf.frag.frag"></src:fragref>
    <src:fragref linkend="page.height.frag"></src:fragref>
    <src:fragref linkend="page.height.portrait.frag"></src:fragref>
    <src:fragref linkend="page.margin.bottom.frag"></src:fragref>
    <src:fragref linkend="page.margin.inner.frag"></src:fragref>
    <src:fragref linkend="page.margin.outer.frag"></src:fragref>
    <src:fragref linkend="page.margin.top.frag"></src:fragref>
    <src:fragref linkend="page.orientation.frag"></src:fragref>
    <src:fragref linkend="page.width.frag"></src:fragref>
    <src:fragref linkend="page.width.portrait.frag"></src:fragref>
    <src:fragref linkend="paper.type.frag"></src:fragref>
    <src:fragref linkend="part.autolabel.frag"></src:fragref>
    <src:fragref linkend="passivetex.extensions.frag"></src:fragref>
    <src:fragref linkend="pgwide.properties.frag"></src:fragref>
    <src:fragref linkend="preface.autolabel.frag"></src:fragref>
    <src:fragref linkend="preferred.mediaobject.role.frag"></src:fragref>
    <src:fragref linkend="procedure.properties.frag"></src:fragref>
    <src:fragref linkend="process.empty.source.toc.frag"></src:fragref>
    <src:fragref linkend="process.source.toc.frag"></src:fragref>
    <src:fragref linkend="profile.arch.frag"></src:fragref>
    <src:fragref linkend="profile.audience.frag"></src:fragref>
    <src:fragref linkend="profile.attribute.frag"></src:fragref>
    <src:fragref linkend="profile.condition.frag"></src:fragref>
    <src:fragref linkend="profile.conformance.frag"></src:fragref>
    <src:fragref linkend="profile.lang.frag"></src:fragref>
    <src:fragref linkend="profile.os.frag"></src:fragref>
    <src:fragref linkend="profile.revision.frag"></src:fragref>
    <src:fragref linkend="profile.revisionflag.frag"></src:fragref>
    <src:fragref linkend="profile.role.frag"></src:fragref>
    <src:fragref linkend="profile.security.frag"></src:fragref>
    <src:fragref linkend="profile.separator.frag"></src:fragref>
    <src:fragref linkend="profile.status.frag"></src:fragref>
    <src:fragref linkend="profile.userlevel.frag"></src:fragref>
    <src:fragref linkend="profile.value.frag"></src:fragref>
    <src:fragref linkend="profile.vendor.frag"></src:fragref>
    <src:fragref linkend="profile.wordsize.frag"></src:fragref>
    <src:fragref linkend="punct.honorific.frag"></src:fragref>
    <src:fragref linkend="qanda.defaultlabel.frag"></src:fragref>
    <src:fragref linkend="qanda.in.toc.frag"></src:fragref>
    <src:fragref linkend="qanda.nested.in.toc.frag"></src:fragref>
    <src:fragref linkend="qanda.inherit.numeration.frag"></src:fragref>
    <src:fragref linkend="qandadiv.autolabel.frag"></src:fragref>
    <src:fragref linkend="qanda.title.level1.properties.frag"></src:fragref>
    <src:fragref linkend="qanda.title.level2.properties.frag"></src:fragref>
    <src:fragref linkend="qanda.title.level3.properties.frag"></src:fragref>
    <src:fragref linkend="qanda.title.level4.properties.frag"></src:fragref>
    <src:fragref linkend="qanda.title.level5.properties.frag"></src:fragref>
    <src:fragref linkend="qanda.title.level6.properties.frag"></src:fragref>
    <src:fragref linkend="qanda.title.properties.frag"></src:fragref>
    <src:fragref linkend="refentry.generate.name.frag"></src:fragref>
    <src:fragref linkend="refentry.generate.title.frag"></src:fragref>
    <src:fragref linkend="refentry.pagebreak.frag"></src:fragref>
    <src:fragref linkend="refentry.title.properties.frag"></src:fragref>
    <src:fragref linkend="refentry.xref.manvolnum.frag"></src:fragref>
    <src:fragref linkend="reference.autolabel.frag"></src:fragref>
    <src:fragref linkend="refclass.suppress.frag"></src:fragref>
    <src:fragref linkend="region.after.extent.frag"></src:fragref>
    <src:fragref linkend="region.before.extent.frag"></src:fragref>
    <src:fragref linkend="revhistory.table.properties.frag"></src:fragref>
    <src:fragref linkend="revhistory.table.cell.properties.frag"></src:fragref>
    <src:fragref linkend="revhistory.title.properties.frag"></src:fragref>
    <src:fragref linkend="root.properties.frag"></src:fragref>
    <src:fragref linkend="rootid.frag"></src:fragref>
    <src:fragref linkend="runinhead.default.title.end.punct.frag"></src:fragref>
    <src:fragref linkend="runinhead.title.end.punct.frag"></src:fragref>
    <src:fragref linkend="sans.font.family.frag"></src:fragref>
    <src:fragref linkend="section.autolabel.frag"></src:fragref>
    <src:fragref linkend="section.autolabel.max.depth.frag"></src:fragref>
    <src:fragref linkend="section.container.element.frag"></src:fragref>
    <src:fragref linkend="section.label.includes.component.label.frag"></src:fragref>
    <src:fragref linkend="section.title.level1.properties.frag"></src:fragref>
    <src:fragref linkend="section.title.level2.properties.frag"></src:fragref>
    <src:fragref linkend="section.title.level3.properties.frag"></src:fragref>
    <src:fragref linkend="section.title.level4.properties.frag"></src:fragref>
    <src:fragref linkend="section.title.level5.properties.frag"></src:fragref>
    <src:fragref linkend="section.title.level6.properties.frag"></src:fragref>
    <src:fragref linkend="section.title.properties.frag"></src:fragref>
    <src:fragref linkend="section.level1.properties.frag"></src:fragref>
    <src:fragref linkend="section.level2.properties.frag"></src:fragref>
    <src:fragref linkend="section.level3.properties.frag"></src:fragref>
    <src:fragref linkend="section.level4.properties.frag"></src:fragref>
    <src:fragref linkend="section.level5.properties.frag"></src:fragref>
    <src:fragref linkend="section.level6.properties.frag"></src:fragref>
    <src:fragref linkend="section.properties.frag"></src:fragref>
    <src:fragref linkend="segmentedlist.as.table.frag"></src:fragref>
    <src:fragref linkend="shade.verbatim.frag"></src:fragref>
    <src:fragref linkend="shade.verbatim.style.frag"></src:fragref>
    <src:fragref linkend="show.comments.frag"></src:fragref>
    <src:fragref linkend="sidebar.properties.frag"></src:fragref>
    <src:fragref linkend="sidebar.title.properties.frag"></src:fragref>
    <src:fragref linkend="sidebar.float.type.frag"></src:fragref>
    <src:fragref linkend="sidebar.float.width.frag"></src:fragref>
    <src:fragref linkend="simplesect.in.toc.frag"></src:fragref>
    <src:fragref linkend="subscript.properties.frag"></src:fragref>
    <src:fragref linkend="superscript.properties.frag"></src:fragref>
    <src:fragref linkend="symbol.font.family.frag"></src:fragref>
    <src:fragref linkend="table.cell.border.color.frag"></src:fragref>
    <src:fragref linkend="table.cell.border.style.frag"></src:fragref>
    <src:fragref linkend="table.cell.border.thickness.frag"></src:fragref>
    <src:fragref linkend="table.cell.padding.frag"></src:fragref>
    <src:fragref linkend="table.footnote.number.format.frag"></src:fragref>
    <src:fragref linkend="table.footnote.number.symbols.frag"></src:fragref>
    <src:fragref linkend="table.footnote.properties.frag"></src:fragref>
    <src:fragref linkend="table.frame.border.color.frag"></src:fragref>
    <src:fragref linkend="table.frame.border.style.frag"></src:fragref>
    <src:fragref linkend="table.frame.border.thickness.frag"></src:fragref>
    <src:fragref linkend="table.properties.frag"></src:fragref>
    <src:fragref linkend="tablecolumns.extension.frag"></src:fragref>
    <src:fragref linkend="table.table.properties.frag"></src:fragref>
    <src:fragref linkend="target.database.document.frag"></src:fragref>
    <src:fragref linkend="targets.filename.frag"></src:fragref>
    <src:fragref linkend="textdata.default.encoding.frag"></src:fragref>
    <src:fragref linkend="tex.math.delims.frag"></src:fragref>
    <src:fragref linkend="tex.math.in.alt.frag"></src:fragref>
    <src:fragref linkend="textinsert.extension.frag"></src:fragref>
    <src:fragref linkend="title.font.family.frag"></src:fragref>
    <src:fragref linkend="title.margin.left.frag"></src:fragref>
    <src:fragref linkend="toc.indent.width.frag"></src:fragref>
    <src:fragref linkend="toc.line.properties.frag"></src:fragref>
    <src:fragref linkend="toc.margin.properties.frag"></src:fragref>
    <src:fragref linkend="toc.max.depth.frag"></src:fragref>
    <src:fragref linkend="toc.section.depth.frag"></src:fragref>
    <src:fragref linkend="ulink.footnotes.frag"></src:fragref>
    <src:fragref linkend="ulink.hyphenate.frag"></src:fragref>
    <src:fragref linkend="ulink.hyphenate.chars.frag"></src:fragref>
    <src:fragref linkend="ulink.show.frag"></src:fragref>
    <src:fragref linkend="use.extensions.frag"></src:fragref>
    <src:fragref linkend="use.local.olink.style.frag"></src:fragref>
    <src:fragref linkend="use.role.as.xrefstyle.frag"></src:fragref>
    <src:fragref linkend="use.role.for.mediaobject.frag"></src:fragref>
    <src:fragref linkend="use.svg.frag"></src:fragref>
    <src:fragref linkend="variablelist.as.blocks.frag"></src:fragref>
    <src:fragref linkend="variablelist.max.termlength.frag"></src:fragref>
    <src:fragref linkend="variablelist.term.separator.frag"></src:fragref>
    <src:fragref linkend="variablelist.term.properties.frag"></src:fragref>
    <src:fragref linkend="variablelist.term.break.after.frag"></src:fragref>
    <src:fragref linkend="verbatim.properties.frag"></src:fragref>
    <src:fragref linkend="writing.mode.frag"></src:fragref>
    <src:fragref linkend="xep.extensions.frag"></src:fragref>
    <src:fragref linkend="xep.index.item.properties.frag"></src:fragref>
    <src:fragref linkend="xref.label-page.separator.frag"></src:fragref>
    <src:fragref linkend="xref.label-title.separator.frag"></src:fragref>
    <src:fragref linkend="xref.properties.frag"></src:fragref>
    <src:fragref linkend="xref.title-page.separator.frag"></src:fragref>
    <src:fragref linkend="xref.with.number.and.title.frag"></src:fragref>

    </xsl:stylesheet>